/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production AbstractWildcardType : {@link TypeDecl};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java5/grammar/Generics.ast:25
 */
public abstract class AbstractWildcardType extends TypeDecl implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AbstractWildcardType clone() throws CloneNotSupportedException {
    AbstractWildcardType node = (AbstractWildcardType) super.clone();
    return node;
  }
  /**
   * 
     * Qualified access for wildcard types.
     * Since they have no ordinary package and type name
     * we just return the bound access.
     
   * @ast method
   * @aspect Generics
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:17
   */

  public Access createQualifiedAccess() {
    // this was suggested by Hyunik Na as a fix for bug
    // http://svn.cs.lth.se/trac/jastadd-trac/ticket/60
    return createBoundAccess();
  }
  /**
   * 
   * @ast method
   * 
   */

  public AbstractWildcardType() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
    setChild(new List(), 1);
  }
  /**
   * 
   * @ast method
   * 
   */

  public AbstractWildcardType(Modifiers p0, String p1, List<BodyDecl> p2) {
    setChild(p0, 0);
    setID(p1);
    setChild(p2, 1);
  }
  /**
   * 
   * @ast method
   * 
   */

  public AbstractWildcardType(Modifiers p0, beaver.Symbol p1, List<BodyDecl> p2) {
    setChild(p0, 0);
    setID(p1);
    setChild(p2, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        needsSignatureAttribute_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Modifiers child.
     * @param node The new node to replace the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setModifiers(Modifiers node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * @return The current node used as the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiers() {
    return (Modifiers) getChild(0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Modifiers child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiersNoTransform() {
    return (Modifiers) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the lexeme ID.
     * @param value The new value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setID(String value) {
    tokenString_ID = value;
  }
  /**
   * 
     * JastAdd-internal setter for lexeme ID using the Beaver parser.
     * @param symbol Symbol containing the new value for the lexeme ID
     * @apilevel internal
     
   * @ast method
   * 
   */

  public void setID(beaver.Symbol symbol) {
    if(symbol.value != null && !(symbol.value instanceof String))
    throw new UnsupportedOperationException("setID is only valid for String lexemes");
    tokenString_ID = (String)symbol.value;
    IDstart = symbol.getStart();
    IDend = symbol.getEnd();
  }
  /**
   * 
     * Retrieves the value for the lexeme ID.
     * @return The value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public String getID() {
    return tokenString_ID != null ? tokenString_ID : "";
  }
  /**
   * 
     * Replaces the BodyDecl list.
     * @param list The new list node to be used as the BodyDecl list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBodyDeclList(List<BodyDecl> list) {
    setChild(list, 1);
  }
  /**
   * 
     * Retrieves the number of children in the BodyDecl list.
     * @return Number of children in the BodyDecl list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumBodyDecl() {
    return getBodyDeclList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the BodyDecl list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the BodyDecl list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumBodyDeclNoTransform() {
    return getBodyDeclListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the BodyDecl list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the BodyDecl list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public BodyDecl getBodyDecl(int i) {
    return (BodyDecl) getBodyDeclList().getChild(i);
  }
  /**
   * 
     * Append an element to the BodyDecl list.
     * @param node The element to append to the BodyDecl list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addBodyDecl(BodyDecl node) {
    List<BodyDecl> list = (parent == null || state == null) ? getBodyDeclListNoTransform() : getBodyDeclList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addBodyDeclNoTransform(BodyDecl node) {
    List<BodyDecl> list = getBodyDeclListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the BodyDecl list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBodyDecl(BodyDecl node, int i) {
    List<BodyDecl> list = getBodyDeclList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the BodyDecl list.
     * @return The node representing the BodyDecl list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<BodyDecl> getBodyDeclList() {
    List<BodyDecl> list = (List<BodyDecl>) getChild(1);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the BodyDecl list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the BodyDecl list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<BodyDecl> getBodyDeclListNoTransform() {
    return (List<BodyDecl>) getChildNoTransform(1);
  }
  /**
   * 
     * Retrieves the BodyDecl list.
     * @return The node representing the BodyDecl list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<BodyDecl> getBodyDecls() {
    return getBodyDeclList();
  }
  /**
   * 
     * Retrieves the BodyDecl list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the BodyDecl list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<BodyDecl> getBodyDeclsNoTransform() {
    return getBodyDeclListNoTransform();
  }
    /**
     * @attribute syn
     * @aspect GenericsSubtype
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericsSubtype.jrag:102
     */
  public boolean isWildcard() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean needsSignatureAttribute_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean needsSignatureAttribute_value;
  /**
   * @attribute syn
   * @aspect GenericsCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/GenericsCodegen.jrag:344
   */

  public boolean needsSignatureAttribute() {
    

    
if(needsSignatureAttribute_computed) {
  return needsSignatureAttribute_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    needsSignatureAttribute_value = needsSignatureAttribute_compute();
      if(isFinal && num == state().boundariesCrossed){ needsSignatureAttribute_computed = true; }
        return needsSignatureAttribute_value;
  }
  /**
   * @apilevel internal
   */
  private boolean needsSignatureAttribute_compute() {  return true;  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
