/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production BasicTWR : {@link Stmt} ::= <span class="component">Resource:{@link ResourceDeclaration}</span> <span class="component">{@link Block}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java7/grammar/BasicTWR.ast:1
 */
public class BasicTWR extends Stmt implements Cloneable, VariableScope {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public BasicTWR clone() throws CloneNotSupportedException {
    BasicTWR node = (BasicTWR) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public BasicTWR copy() {
    try {
      BasicTWR node = (BasicTWR) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public BasicTWR fullCopy() {
    BasicTWR tree = (BasicTWR) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
     * The general structure of the basic try-with-resources:
     *
     * <pre><code>
     * RESOURCE
     * BLOCK
     *
     * Primary Exception Handler
     *   Automatic Closing of Resource
     *     Suppressed Exception Handler
     *   re-throw primary exception
     * Automatic Closing of Resource
     * </pre></code>
     *
     * Pseudocode for basic try-with-resources:
     *
     * <pre><code>
     * 0  .resourceBegin
     * 1  emit RESOURCE
     * 0  store resource
     * 0  .resourceEnd
     *
     * 0  .blockBegin
     * 0  emit BLOCK
     * 0  .blockEnd
     * 0  goto outerFinally
     *
     * 1  .resourceException
     * 1  throw
     *
     * #if BLOCK is not empty:
     *
     * 1  .catchPrimary
     * 0  store primary
     *
     * 0  .tryCloseBegin
     * 1  load resource
     * 0  ifnull innerFinally
     * 1  load resource
     * 0  invoke java.lang.AutoCloseable.close()
     * 0  .tryCloseEnd
     *
     * 0  goto innerFinally
     *
     * 1  .catchSuppressed
     * 0  store suppressed
     * 1  load primary
     * 2  load suppressed
     * 0  invoke java.lang.Throwable.addSuppressed(Throwable)
     *
     * 0  .innerFinally
     * 1  load primary
     * 1  throw
     *
     * #endif BLOCK is not empty
     *
     * 0  .outerFinally
     * 1  load resource
     * 0  ifnull tryEnd
     * 1  load resource
     * 0  invoke java.lang.AutoCloseable.close()
     *
     * 0  .tryEnd
     *
     * Exception Table:
     * resourceBegin .. resourceEnd : resourceException
     * blockBegin .. blockEnd : catchPrimary
     * tryCloseBegin .. tryCloseEnd : catchSuppressed
     * </pre></code>
     *
     
   * @ast method
   * @aspect TryWithResources
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/TryWithResources.jrag:136
   */

  public void createBCode(CodeGeneration gen) {
    ResourceDeclaration resource = getResource();

    int resourceBeginLbl = hostType().constantPool().newLabel();
    int resourceEndLbl = hostType().constantPool().newLabel();
    int blockBeginLbl = hostType().constantPool().newLabel();
    int blockEndLbl = hostType().constantPool().newLabel();
    int tryCloseBeginLbl = hostType().constantPool().newLabel();
    int tryCloseEndLbl = hostType().constantPool().newLabel();

    int resourceExceptionLbl = hostType().constantPool().newLabel();
    int catchPrimaryLbl = hostType().constantPool().newLabel();
    int catchSuppressedLbl = hostType().constantPool().newLabel();
    int innerFinallyLbl = hostType().constantPool().newLabel();
    int outerFinallyLbl = hostType().constantPool().newLabel();
    int tryEndLbl = hostType().constantPool().newLabel();

    TypeDecl throwableType = lookupType("java.lang", "Throwable");
    TypeDecl resourceType = resource.type();
    TypeDecl autoCloseableType = lookupType("java.lang", "AutoCloseable");

    gen.changeStackDepth(3);
    int resourceIndex = resource.localNum();
    int primaryIndex = resourceIndex+resourceType.variableSize();
    int suppressedIndex = primaryIndex+throwableType.variableSize();

    // store the resource in local
    gen.addLabel(resourceBeginLbl);
    resource.createBCode(gen);
    gen.addLabel(resourceEndLbl);
    gen.emit(Bytecode.NOP);

    gen.addLabel(blockBeginLbl);
    getBlock().createBCode(gen);
    gen.addLabel(blockEndLbl);
    gen.emitGoto(outerFinallyLbl);

    // If there was an exception when initializing the resource
    // we need to directly rethrow the exception
    gen.addLabel(resourceExceptionLbl);
    gen.emitThrow();
    gen.addException(
      resourceBeginLbl,
      resourceEndLbl,
      resourceExceptionLbl,
      CodeGeneration.ExceptionEntry.CATCH_ALL);

    if (gen.addressOf(blockBeginLbl) != gen.addressOf(blockEndLbl)) {

      // catch primary exception
      // operand stack: .., #primary
      gen.addLabel(catchPrimaryLbl);
      throwableType.emitStoreLocal(gen, primaryIndex);

      // try-close resource
      gen.addLabel(tryCloseBeginLbl);
      {
        // if resource != null
        resourceType.emitLoadLocal(gen, resourceIndex);
        gen.emitCompare(Bytecode.IFNULL, innerFinallyLbl);
        resourceType.emitLoadLocal(gen, resourceIndex);
        closeMethod().emitInvokeMethod(gen, autoCloseableType);
      }
      gen.addLabel(tryCloseEndLbl);
      gen.emitGoto(innerFinallyLbl);

      // catch suppressed exception
      // operand stack: .., #primary, #suppressed
      gen.addLabel(catchSuppressedLbl);
      throwableType.emitStoreLocal(gen, suppressedIndex);
      throwableType.emitLoadLocal(gen, primaryIndex);
      throwableType.emitLoadLocal(gen, suppressedIndex);
      addSuppressedMethod().emitInvokeMethod(gen, throwableType);

      // inner finally
      // operand stack: .., #primary
      gen.addLabel(innerFinallyLbl);
      throwableType.emitLoadLocal(gen, primaryIndex);
      gen.emitThrow();

      // If there was an exception during the block of the try
      // statement, then we should try to close the resource
      gen.addException(
        blockBeginLbl,
        blockEndLbl,
        catchPrimaryLbl,
        CodeGeneration.ExceptionEntry.CATCH_ALL);

      // If an exception occurrs during the automatic closing
      // of a resource after an exception in the try block...
      gen.addException(
        tryCloseBeginLbl,
        tryCloseEndLbl,
        catchSuppressedLbl,
        CodeGeneration.ExceptionEntry.CATCH_ALL);
    }

    // outer finally
    gen.addLabel(outerFinallyLbl);
    {
      // if resource != null
      resourceType.emitLoadLocal(gen, resourceIndex);
      gen.emitCompare(Bytecode.IFNULL, tryEndLbl);
      resourceType.emitLoadLocal(gen, resourceIndex);
      closeMethod().emitInvokeMethod(gen, autoCloseableType);
    }

    gen.addLabel(tryEndLbl);
    gen.emit(Bytecode.NOP);
  }
  /**
   * 
     * Lookup the java.lang.Throwable.close() method.
     
   * @ast method
   * @aspect TryWithResources
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/TryWithResources.jrag:250
   */

  private MethodDecl closeMethod() {
    TypeDecl autoCloseableType = lookupType("java.lang", "AutoCloseable");
    if (autoCloseableType == null)
      throw new Error("Could not find java.lang.AutoCloseable");
    for (MethodDecl method : (Collection<MethodDecl>)
        autoCloseableType.memberMethods("close")) {
      if (method.getNumParameter() == 0)
        return method;
    }
    throw new Error("Could not find java.lang.AutoCloseable.close()");
  }
  /**
   * 
     * Lookup the java.lang.Throwable.addSuppressed(Throwable) method.
     
   * @ast method
   * @aspect TryWithResources
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/TryWithResources.jrag:265
   */

  private MethodDecl addSuppressedMethod() {
    TypeDecl throwableType = lookupType("java.lang", "Throwable");
    if (throwableType == null)
      throw new Error("Could not find java.lang.Throwable");
    for (MethodDecl method : (Collection<MethodDecl>)
        throwableType.memberMethods("addSuppressed")) {
      if (method.getNumParameter() == 1 &&
          method.getParameter(0).getTypeAccess().type() ==
          throwableType) {
        return method;
      }
    }
    throw new Error("Could not find java.lang.Throwable.addSuppressed()");
  }
  /**
   * 
   * @ast method
   * 
   */

  public BasicTWR() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public BasicTWR(ResourceDeclaration p0, Block p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        localLookup_String_values = null;
    localVariableDeclaration_String_values = null;
    lookupVariable_String_values = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Resource child.
     * @param node The new node to replace the Resource child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setResource(ResourceDeclaration node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Resource child.
     * @return The current node used as the Resource child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public ResourceDeclaration getResource() {
    return (ResourceDeclaration) getChild(0);
  }
  /**
   * 
     * Retrieves the Resource child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Resource child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public ResourceDeclaration getResourceNoTransform() {
    return (ResourceDeclaration) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Block child.
     * @param node The new node to replace the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBlock(Block node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Block child.
     * @return The current node used as the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Block getBlock() {
    return (Block) getChild(1);
  }
  /**
   * 
     * Retrieves the Block child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Block getBlockNoTransform() {
    return (Block) getChildNoTransform(1);
  }
  protected java.util.Map localLookup_String_values;
  /**
   * @attribute syn
   * @aspect MultiCatch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/MultiCatch.jrag:78
   */

  public SimpleSet localLookup(String name) {
    Object _parameters = name;
    if(localLookup_String_values == null) localLookup_String_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(localLookup_String_values.containsKey(_parameters)) {
  return (SimpleSet)localLookup_String_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    SimpleSet localLookup_String_value = localLookup_compute(name);
      if(isFinal && num == state().boundariesCrossed){ localLookup_String_values.put(_parameters, localLookup_String_value); }
        return localLookup_String_value;
  }
  /**
   * @apilevel internal
   */
  private SimpleSet localLookup_compute(String name) {
      VariableDeclaration v = localVariableDeclaration(name);
      if (v != null) return v;
      return lookupVariable(name);
    }
  protected java.util.Map localVariableDeclaration_String_values;
  /**
   * @attribute syn
   * @aspect MultiCatch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/MultiCatch.jrag:83
   */

  public VariableDeclaration localVariableDeclaration(String name) {
    Object _parameters = name;
    if(localVariableDeclaration_String_values == null) localVariableDeclaration_String_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(localVariableDeclaration_String_values.containsKey(_parameters)) {
  return (VariableDeclaration)localVariableDeclaration_String_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    VariableDeclaration localVariableDeclaration_String_value = localVariableDeclaration_compute(name);
      if(isFinal && num == state().boundariesCrossed){ localVariableDeclaration_String_values.put(_parameters, localVariableDeclaration_String_value); }
        return localVariableDeclaration_String_value;
  }
  /**
   * @apilevel internal
   */
  private VariableDeclaration localVariableDeclaration_compute(String name) {  return getResource().declaresVariable(name) ? getResource() : null;  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return getBlock().modifiedInScope(var);  }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect MultiCatch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/MultiCatch.jrag:87
   */

  public SimpleSet lookupVariable(String name) {
    Object _parameters = name;
    if(lookupVariable_String_values == null) lookupVariable_String_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(lookupVariable_String_values.containsKey(_parameters)) {
  return (SimpleSet)lookupVariable_String_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    SimpleSet lookupVariable_String_value = getParent().Define_SimpleSet_lookupVariable(this, null, name);
      if(isFinal && num == state().boundariesCrossed){ lookupVariable_String_values.put(_parameters, lookupVariable_String_value); }
        return lookupVariable_String_value;
  }
  protected java.util.Map lookupVariable_String_values;
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/MultiCatch.jrag:76
   * @apilevel internal
   */
  public SimpleSet Define_SimpleSet_lookupVariable(ASTNode caller, ASTNode child, String name) {
    if(caller == getBlockNoTransform()) {
      return localLookup(name);
    }
    else {      return getParent().Define_SimpleSet_lookupVariable(this, caller, name);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/TryWithResources.jrag:292
   * @apilevel internal
   */
  public int Define_int_localNum(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return getResource().localNum() +
    getResource().type().variableSize() +
    2 * lookupType("java.lang", "Throwable").variableSize();
    }
    else if(caller == getResourceNoTransform()) {
      return localNum();
    }
    else {      return getParent().Define_int_localNum(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
