/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production ConstructorDecl : {@link BodyDecl} ::= <span class="component">{@link Modifiers}</span> <span class="component">&lt;ID:String&gt;</span> <span class="component">Parameter:{@link ParameterDeclaration}*</span> <span class="component">Exception:{@link Access}*</span> <span class="component">[ConstructorInvocation:{@link Stmt}]</span> <span class="component">{@link Block}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:74
 */
public class ConstructorDecl extends BodyDecl implements Cloneable, ExceptionHolder {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ConstructorDecl clone() throws CloneNotSupportedException {
    ConstructorDecl node = (ConstructorDecl) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ConstructorDecl copy() {
    try {
      ConstructorDecl node = (ConstructorDecl) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ConstructorDecl fullCopy() {
    ConstructorDecl tree = (ConstructorDecl) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:146
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	if(isDefaultConstructor()) return;
	s.append(indent());
	getModifiers().prettyPrint(s);
	s.append(name() + "(");
	if(getNumParameter() > 0) {
	  getParameter(0).prettyPrint(s);
	  for(int i = 1; i < getNumParameter(); i++) {
		s.append(", ");
		getParameter(i).prettyPrint(s);
	  }
	}
	s.append(")");
	if(getNumException() > 0) {
	  s.append(" throws ");
	  getException(0).prettyPrint(s);
	  for(int i = 1; i < getNumException(); i++) {
		s.append(", ");
		getException(i).prettyPrint(s);
	  }
	}

	s.append(" {");
	if(hasConstructorInvocation()) {
	  getConstructorInvocation().prettyPrint(s);
	}
	for(int i = 0; i < getBlock().getNumStmt(); i++) {
	  getBlock().getStmt(i).prettyPrint(s);
	}
	s.append(indent());
	s.append("}");
  }
  /**
   * 
   * @ast method
   * @aspect ConstructorDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:144
   */

  public boolean applicable(List argList) {
    if(getNumParameter() != argList.getNumChild())
      return false;
    for(int i = 0; i < getNumParameter(); i++) {
      TypeDecl arg = ((Expr)argList.getChild(i)).type();
      TypeDecl parameter = getParameter(i).type();
      if(!arg.instanceOf(parameter)) {
        return false;
      }
    }
    return true;
  }
  /**
   * 
     * Flag to indicate if this constructor is an auto-generated
     * default constructor. Default constructors are not pretty
     * printed.
     
   * @ast method
   * @aspect ImplicitConstructor
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:171
   */

  

  /**
   * Flag to indicate if this constructor is an auto-generated
   * default constructor. Default constructors are not pretty
   * printed.
   */
  private boolean isDefaultConstructor = false;
  /**
   * 
     * Set the default constructor flag. Causes this constructor
     * to not be pretty printed.
     
   * @ast method
   * @aspect ImplicitConstructor
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:176
   */

  public void setDefaultConstructor() {
    isDefaultConstructor = true;
  }
  /**
   * 
   * @ast method
   * @aspect Modifiers
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:110
   */

  public void checkModifiers() {
    super.checkModifiers();
  }
  /**
   * 
   * @ast method
   * @aspect NameCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:93
   */

  public void nameCheck() {
    super.nameCheck();
    // 8.8
    if(!hostType().name().equals(name()))
      error("constructor " + name() +" does not have the same name as the simple name of the host class " + hostType().name());

    // 8.8.2
    if(hostType().lookupConstructor(this) != this)
      error("constructor with signature " + signature() + " is multiply declared in type " + hostType().typeName());

    if(circularThisInvocation(this))
      error("The constructor " + signature() + " may not directly or indirectly invoke itself");
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:119
   */

  public void toString(StringBuffer s) {
	if(isDefaultConstructor()) return;
	s.append(indent());
	getModifiers().toString(s);
	s.append(name() + "(");
	if(getNumParameter() > 0) {
	  getParameter(0).toString(s);
	  for(int i = 1; i < getNumParameter(); i++) {
		s.append(", ");
		getParameter(i).toString(s);
	  }
	}
	s.append(")");
	if(getNumException() > 0) {
	  s.append(" throws ");
	  getException(0).toString(s);
	  for(int i = 1; i < getNumException(); i++) {
		s.append(", ");
		getException(i).toString(s);
	  }
	}

	s.append(" {");
	if(hasConstructorInvocation()) {
	  getConstructorInvocation().toString(s);
	}
	for(int i = 0; i < getBlock().getNumStmt(); i++) {
	  getBlock().getStmt(i).toString(s);
	}
	s.append(indent());
	s.append("}");
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:424
   */

  public void typeCheck() {
    // 8.8.4 (8.4.4)
    TypeDecl exceptionType = typeThrowable();
    for(int i = 0; i < getNumException(); i++) {
      TypeDecl typeDecl = getException(i).type();
      if(!typeDecl.instanceOf(exceptionType))
        error(signature() + " throws non throwable type " + typeDecl.fullName());
    }
  }
  /**
   * 
   * @ast method
   * @aspect CodeGeneration
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:464
   */

  public void emitInvokeConstructor(CodeGeneration gen) {
    int size = -1;
    for(int i = 0; i < getNumParameter(); i++)
      size -= getParameter(i).type().variableSize();
    if(hostType().needsEnclosing())
      size--;
    if(hostType().needsSuperEnclosing()) {
      size--;
    }
    String classname = hostType().constantPoolName();
    String      desc = descName();
    String      name = "<init>";
    int index = gen.constantPool().addMethodref(classname, name, desc);
    gen.emit(Bytecode.INVOKESPECIAL, size).add2(index);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:133
   */

  private void generateBytecodes(CodeGeneration gen) {
    int label = gen.variableScopeLabel();
    gen.addLocalVariableEntryAtCurrentPC("this", hostType().typeDescriptor(), 0, label);
    for(int i = 0; i < getNumParameter(); i++) {
      ParameterDeclaration p = (ParameterDeclaration)getParameter(i);
      gen.addLocalVariableEntryAtCurrentPC(
        p.name(), p.type().typeDescriptor(), p.localNum(), label
      );
    }
    createBCode(gen);
    gen.emitReturn();
    gen.addVariableScopeLabel(label);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:159
   */

  public void createBCode(CodeGeneration gen) {
    try {
    boolean needsInit = true;

    if(hasConstructorInvocation()) {
      getConstructorInvocation().createBCode(gen);
      Stmt stmt = getConstructorInvocation();
      if(stmt instanceof ExprStmt) {
        ExprStmt exprStmt = (ExprStmt)stmt;
        Expr expr = exprStmt.getExpr();
        if(!expr.isSuperConstructorAccess())
          needsInit = false;

      }
    }

    if(needsEnclosing()) {
      gen.emitLoadReference(0);
      gen.emitLoadReference(1);
      String classname = hostType().constantPoolName();
      String desc = enclosing().typeDescriptor();
      String name = "this$0";
      int index = gen.constantPool().addFieldref(classname, name, desc);
      gen.emit(Bytecode.PUTFIELD, -2).add2(index);
    }

    int localIndex = offsetFirstEnclosingVariable();
    for(Iterator iter = hostType().enclosingVariables().iterator(); iter.hasNext(); ) {
        Variable v = (Variable)iter.next();
        gen.emitLoadReference(0);
        v.type().emitLoadLocal(gen, localIndex);
        String classname = hostType().constantPoolName();
        String desc = v.type().typeDescriptor();
        String name = "val$" + v.name();
        int index = gen.constantPool().addFieldref(classname, name, desc);
        gen.emit(Bytecode.PUTFIELD, -1 - v.type().variableSize()).add2(index);
        localIndex += v.type().variableSize();
    }

    if(needsInit) {
      TypeDecl typeDecl = hostType();
      for(int i = 0; i < typeDecl.getNumBodyDecl(); i++) {
        BodyDecl b = typeDecl.getBodyDecl(i);
        if(b instanceof FieldDeclaration && b.isBytecodeField() && b.generate()) {
          FieldDeclaration f = (FieldDeclaration)b;
          if(!f.isStatic() && f.hasInit()) {
            gen.emit(Bytecode.ALOAD_0);
            f.getInit().createBCode(gen);
            f.getInit().type().emitAssignConvTo(gen, f.type()); // AssignConversion
            f.emitStoreField(gen, hostType());
          }
        }
        else if(b instanceof InstanceInitializer) {
          b.createBCode(gen);
        }
      }
    }
    gen.maxLocals = Math.max(gen.maxLocals, getBlock().localNum());
    getBlock().createBCode(gen);
    } catch (Error e) {
      System.err.println(hostType().typeName() + ": " + this);
      throw e;
    }
  }
  /**
   * 
   * @ast method
   * @aspect GenerateClassfile
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/GenerateClassfile.jrag:252
   */

  public void generateMethod(DataOutputStream out, ConstantPool cp) throws IOException {
    out.writeChar(flags());
    out.writeChar(cp.addUtf8("<init>"));
    out.writeChar(cp.addUtf8(descName()));
    out.writeChar(attributes().size());
    for(Iterator itera = attributes().iterator(); itera.hasNext();)
      ((Attribute)itera.next()).emit(out);
  }
  /**
   * 
   * @ast method
   * @aspect GenerateClassfile
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/GenerateClassfile.jrag:268
   */

  public void touchMethod(ConstantPool cp) {
    cp.addUtf8("<init>");
    cp.addUtf8(descName());
    attributes();
  }
  /**
   * 
   * @ast method
   * @aspect GenerateClassfile
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/GenerateClassfile.jrag:376
   */

  public boolean clear() {
    getBlock().clear();
    setBlock(new Block(new List()));
    bytecodes_ConstantPool_values = null;
    return false;
  }
  /**
   * 
   * @ast method
   * @aspect InnerClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:457
   */

  

  // add val$name as parameters to the constructor
  protected boolean addEnclosingVariables = true;
  /**
   * 
   * @ast method
   * @aspect InnerClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:458
   */

  public void addEnclosingVariables() {
    if(!addEnclosingVariables) return;
    addEnclosingVariables = false;
    hostType().addEnclosingVariables();
    for(Iterator iter = hostType().enclosingVariables().iterator(); iter.hasNext(); ) {
      Variable v = (Variable)iter.next();
      getParameterList().add(new ParameterDeclaration(v.type(), "val$" + v.name()));
    }
  }
  /**
   * 
   * @ast method
   * @aspect InnerClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:492
   */

  public ConstructorDecl createAccessor() {
    ConstructorDecl c = (ConstructorDecl)hostType().getAccessor(this, "constructor");
    if(c != null) return c;

    // make sure enclosing varibles are added as parameters prior to building accessor
    addEnclosingVariables();

    Modifiers modifiers = new Modifiers(new List());
    modifiers.addModifier(new Modifier("synthetic"));
    modifiers.addModifier(new Modifier("public"));

    List parameters = createAccessorParameters();

    List exceptionList = new List();
    for(int i = 0; i < getNumException(); i++)
      exceptionList.add(getException(i).type().createQualifiedAccess());

    // add all parameters as arguments except for the dummy parameter
    List args = new List();
    for(int i = 0; i < parameters.getNumChildNoTransform() - 1; i++)
      args.add(new VarAccess(((ParameterDeclaration)parameters.getChildNoTransform(i)).name()));
    ConstructorAccess access = new ConstructorAccess("this", args);
    access.addEnclosingVariables = false;

    c = new ConstructorDecl(
      modifiers,
      name(),
      parameters,
      exceptionList,
      new Opt(
        new ExprStmt(
          access
        )
      ),
      new Block(
        new List().add(new ReturnStmt(new Opt()))
      )
    );
    c = hostType().addConstructor(c);
    c.addEnclosingVariables = false;
    hostType().addAccessor(this, "constructor", c);
    return c;
  }
  /**
   * 
   * @ast method
   * @aspect InnerClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:536
   */

  protected List createAccessorParameters() {
    List parameters = new List();
    for (int i=0; i<getNumParameter(); i++)
      parameters.add(new ParameterDeclaration(getParameter(i).type(), getParameter(i).name()));
    parameters.add(new ParameterDeclaration(createAnonymousJavaTypeDecl().createBoundAccess(), ("p" + getNumParameter())));
    return parameters;
  }
  /**
   * 
   * @ast method
   * @aspect InnerClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:544
   */

  protected TypeDecl createAnonymousJavaTypeDecl() {
    ClassDecl classDecl =
      new ClassDecl(
          new Modifiers(new List().add(new Modifier("synthetic"))),
          "" + hostType().nextAnonymousIndex(),
          new Opt(),
          new List(),
          new List()
      );
    classDecl = hostType().addMemberClass(classDecl);
    hostType().addNestedType(classDecl);
    return classDecl;
  }
  /**
   * 
   * @ast method
   * @aspect Transformations
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/Transformations.jrag:119
   */

  public void transformation() {
    // this$val as fields and constructor parameters
    addEnclosingVariables();
    super.transformation();
  }
  /**
   * 
   * @ast method
   * @aspect Enums
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Enums.jrag:138
   */

  protected void transformEnumConstructors() {
    // make sure constructor is private
    Modifiers newModifiers = new Modifiers(new List());
    for (int i = 0; i < getModifiers().getNumModifier(); ++i) {
      String modifier = getModifiers().getModifier(i).getID();
      if (modifier.equals("public") || modifier.equals("private") ||
        modifier.equals("protected"))
          continue;
      newModifiers.addModifier(new Modifier(modifier));
    }
    newModifiers.addModifier(new Modifier("private"));
    setModifiers(newModifiers);

    // add implicit super constructor access since we are traversing
    // without doing rewrites
    if(!hasConstructorInvocation()) {
      setConstructorInvocation(
        new ExprStmt(
          new SuperConstructorAccess("super", new List())
        )
      );
    }
    super.transformEnumConstructors();
    getParameterList().insertChild(
      new ParameterDeclaration(new TypeAccess("java.lang", "String"), "@p0"),
      0
    );
    getParameterList().insertChild(
      new ParameterDeclaration(new TypeAccess("int"), "@p1"),
      1
    );
  }
  /**
   * 
   * @ast method
   * @aspect LookupParTypeDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:1283
   */

  public BodyDecl substitutedBodyDecl(Parameterization parTypeDecl) {
    ConstructorDecl c = new ConstructorDeclSubstituted(
      (Modifiers)getModifiers().fullCopy(),
      getID(),
      getParameterList().substitute(parTypeDecl),
      getExceptionList().substitute(parTypeDecl),
      new Opt(),
      new Block(),
      this
    );
    return c;
  }
  /**
   * 
   * @ast method
   * 
   */

  public ConstructorDecl() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[5];
    setChild(new List(), 1);
    setChild(new List(), 2);
    setChild(new Opt(), 3);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ConstructorDecl(Modifiers p0, String p1, List<ParameterDeclaration> p2, List<Access> p3, Opt<Stmt> p4, Block p5) {
    setChild(p0, 0);
    setID(p1);
    setChild(p2, 1);
    setChild(p3, 2);
    setChild(p4, 3);
    setChild(p5, 4);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ConstructorDecl(Modifiers p0, beaver.Symbol p1, List<ParameterDeclaration> p2, List<Access> p3, Opt<Stmt> p4, Block p5) {
    setChild(p0, 0);
    setID(p1);
    setChild(p2, 1);
    setChild(p3, 2);
    setChild(p4, 3);
    setChild(p5, 4);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 5;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return true;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        accessibleFrom_TypeDecl_values = null;
    isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    throwsException_TypeDecl_values = null;
    name_computed = false;
    name_value = null;
    signature_computed = false;
    signature_value = null;
    sameSignature_ConstructorDecl_values = null;
    moreSpecificThan_ConstructorDecl_values = null;
    parameterDeclaration_String_values = null;
    circularThisInvocation_ConstructorDecl_values = null;
    attributes_computed = false;
    attributes_value = null;
    descName_computed = false;
    descName_value = null;
    bytecodes_ConstantPool_values = null;
    flags_computed = false;
    localNumOfFirstParameter_computed = false;
    offsetFirstEnclosingVariable_computed = false;
    sourceConstructorDecl_computed = false;
    sourceConstructorDecl_value = null;
    handlesException_TypeDecl_values = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Modifiers child.
     * @param node The new node to replace the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setModifiers(Modifiers node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * @return The current node used as the Modifiers child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiers() {
    return (Modifiers) getChild(0);
  }
  /**
   * 
     * Retrieves the Modifiers child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Modifiers child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Modifiers getModifiersNoTransform() {
    return (Modifiers) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the lexeme ID.
     * @param value The new value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setID(String value) {
    tokenString_ID = value;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  

  /**
   * @apilevel internal
   */
  protected String tokenString_ID;
  /**
   * 
   * @ast method
   * 
   */

  

  public int IDstart;
  /**
   * 
   * @ast method
   * 
   */

  
  public int IDend;
  /**
   * 
     * JastAdd-internal setter for lexeme ID using the Beaver parser.
     * @param symbol Symbol containing the new value for the lexeme ID
     * @apilevel internal
     
   * @ast method
   * 
   */

  public void setID(beaver.Symbol symbol) {
    if(symbol.value != null && !(symbol.value instanceof String))
    throw new UnsupportedOperationException("setID is only valid for String lexemes");
    tokenString_ID = (String)symbol.value;
    IDstart = symbol.getStart();
    IDend = symbol.getEnd();
  }
  /**
   * 
     * Retrieves the value for the lexeme ID.
     * @return The value for the lexeme ID.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public String getID() {
    return tokenString_ID != null ? tokenString_ID : "";
  }
  /**
   * 
     * Replaces the Parameter list.
     * @param list The new list node to be used as the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setParameterList(List<ParameterDeclaration> list) {
    setChild(list, 1);
  }
  /**
   * 
     * Retrieves the number of children in the Parameter list.
     * @return Number of children in the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumParameter() {
    return getParameterList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the Parameter list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the Parameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumParameterNoTransform() {
    return getParameterListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the Parameter list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public ParameterDeclaration getParameter(int i) {
    return (ParameterDeclaration) getParameterList().getChild(i);
  }
  /**
   * 
     * Append an element to the Parameter list.
     * @param node The element to append to the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addParameter(ParameterDeclaration node) {
    List<ParameterDeclaration> list = (parent == null || state == null) ? getParameterListNoTransform() : getParameterList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addParameterNoTransform(ParameterDeclaration node) {
    List<ParameterDeclaration> list = getParameterListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the Parameter list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setParameter(ParameterDeclaration node, int i) {
    List<ParameterDeclaration> list = getParameterList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the Parameter list.
     * @return The node representing the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<ParameterDeclaration> getParameterList() {
    List<ParameterDeclaration> list = (List<ParameterDeclaration>) getChild(1);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the Parameter list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Parameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<ParameterDeclaration> getParameterListNoTransform() {
    return (List<ParameterDeclaration>) getChildNoTransform(1);
  }
  /**
   * 
     * Retrieves the Parameter list.
     * @return The node representing the Parameter list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<ParameterDeclaration> getParameters() {
    return getParameterList();
  }
  /**
   * 
     * Retrieves the Parameter list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Parameter list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<ParameterDeclaration> getParametersNoTransform() {
    return getParameterListNoTransform();
  }
  /**
   * 
     * Replaces the Exception list.
     * @param list The new list node to be used as the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setExceptionList(List<Access> list) {
    setChild(list, 2);
  }
  /**
   * 
     * Retrieves the number of children in the Exception list.
     * @return Number of children in the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumException() {
    return getExceptionList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the Exception list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the Exception list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumExceptionNoTransform() {
    return getExceptionListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the Exception list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Access getException(int i) {
    return (Access) getExceptionList().getChild(i);
  }
  /**
   * 
     * Append an element to the Exception list.
     * @param node The element to append to the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addException(Access node) {
    List<Access> list = (parent == null || state == null) ? getExceptionListNoTransform() : getExceptionList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addExceptionNoTransform(Access node) {
    List<Access> list = getExceptionListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the Exception list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setException(Access node, int i) {
    List<Access> list = getExceptionList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the Exception list.
     * @return The node representing the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Access> getExceptionList() {
    List<Access> list = (List<Access>) getChild(2);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the Exception list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Exception list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Access> getExceptionListNoTransform() {
    return (List<Access>) getChildNoTransform(2);
  }
  /**
   * 
     * Retrieves the Exception list.
     * @return The node representing the Exception list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<Access> getExceptions() {
    return getExceptionList();
  }
  /**
   * 
     * Retrieves the Exception list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Exception list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<Access> getExceptionsNoTransform() {
    return getExceptionListNoTransform();
  }
  /**
   * 
     * Replaces the optional node for the ConstructorInvocation child. This is the {@code Opt}
     * node containing the child ConstructorInvocation, not the actual child!
     * @param opt The new node to be used as the optional node for the ConstructorInvocation child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void setConstructorInvocationOpt(Opt<Stmt> opt) {
    setChild(opt, 3);
  }
  /**
   * 
     * Replaces the (optional) ConstructorInvocation child.
     * @param node The new node to be used as the ConstructorInvocation child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setConstructorInvocation(Stmt node) {
    getConstructorInvocationOpt().setChild(node, 0);
  }
  /**
   * 
     * Check whether the optional ConstructorInvocation child exists.
     * @return {@code true} if the optional ConstructorInvocation child exists, {@code false} if it does not.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public boolean hasConstructorInvocation() {
    return getConstructorInvocationOpt().getNumChild() != 0;
  }
  /**
   * 
     * Retrieves the (optional) ConstructorInvocation child.
     * @return The ConstructorInvocation child, if it exists. Returns {@code null} otherwise.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Stmt getConstructorInvocation() {
    return (Stmt) getConstructorInvocationOpt().getChild(0);
  }
  /**
   * 
     * Retrieves the optional node for the ConstructorInvocation child. This is the {@code Opt} node containing the child ConstructorInvocation, not the actual child!
     * @return The optional node for child the ConstructorInvocation child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Stmt> getConstructorInvocationOpt() {
    return (Opt<Stmt>) getChild(3);
  }
  /**
   * 
     * Retrieves the optional node for child ConstructorInvocation. This is the {@code Opt} node containing the child ConstructorInvocation, not the actual child!
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The optional node for child ConstructorInvocation.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Stmt> getConstructorInvocationOptNoTransform() {
    return (Opt<Stmt>) getChildNoTransform(3);
  }
  /**
   * 
     * Replaces the Block child.
     * @param node The new node to replace the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBlock(Block node) {
    setChild(node, 4);
  }
  /**
   * 
     * Retrieves the Block child.
     * @return The current node used as the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Block getBlock() {
    return (Block) getChild(4);
  }
  /**
   * 
     * Retrieves the Block child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Block getBlockNoTransform() {
    return (Block) getChildNoTransform(4);
  }
  /**
   * 
   * @ast method
   * @aspect ConstructorDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:136
   */

  private boolean refined_ConstructorDecl_ConstructorDecl_moreSpecificThan_ConstructorDecl(ConstructorDecl m)
{
    for(int i = 0; i < getNumParameter(); i++) {
      if(!getParameter(i).type().instanceOf(m.getParameter(i).type()))
        return false;
    }
    return true;
  }
  /**
   * 
   * @ast method
   * @aspect Attributes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/Attributes.jrag:198
   */

  private Collection refined_Attributes_ConstructorDecl_attributes()
{
    ArrayList l = new ArrayList();
    l.add(new CodeAttribute(bytecodes(hostType().constantPool()), null));
    l.add(new ExceptionsAttribute(bytecodes(hostType().constantPool()), this));
    if(getModifiers().isSynthetic())
      l.add(new SyntheticAttribute(hostType().constantPool()));
    return l;
  }
  /**
   * 
   * @ast method
   * @aspect Flags
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/Flags.jrag:54
   */

  private int refined_Flags_ConstructorDecl_flags()
{
    int res = 0;
    if(isPublic()) res |= Modifiers.ACC_PUBLIC;
    if(isPrivate()) res |= Modifiers.ACC_PRIVATE;
    if(isProtected()) res |= Modifiers.ACC_PROTECTED;
    //if(isSynchronized()) res |= Modifiers.ACC_SYNCHRONIZED;
    //if(isStrictfp()) res |= Modifiers.ACC_STRICT;
    return res;
  }
  protected java.util.Map accessibleFrom_TypeDecl_values;
  /**
   * @attribute syn
   * @aspect AccessControl
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/AccessControl.jrag:94
   */

  public boolean accessibleFrom(TypeDecl type) {
    Object _parameters = type;
    if(accessibleFrom_TypeDecl_values == null) accessibleFrom_TypeDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(accessibleFrom_TypeDecl_values.containsKey(_parameters)) {
  return ((Boolean)accessibleFrom_TypeDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean accessibleFrom_TypeDecl_value = accessibleFrom_compute(type);
      if(isFinal && num == state().boundariesCrossed){ accessibleFrom_TypeDecl_values.put(_parameters, Boolean.valueOf(accessibleFrom_TypeDecl_value)); }
        return accessibleFrom_TypeDecl_value;
  }
  /**
   * @apilevel internal
   */
  private boolean accessibleFrom_compute(TypeDecl type) {
      if(!hostType().accessibleFrom(type))
        return false;
      else if(isPublic())
        return true;
      else if(isProtected()) {
        return true;
      }
      else if(isPrivate()) {
        return hostType().topLevelType() == type.topLevelType();
      }
      else
        return hostPackage().equals(type.hostPackage());
    }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:295
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {  return getBlock().isDAafter(v) && getBlock().checkReturnDA(v);  }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:752
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {  return getBlock().isDUafter(v) && getBlock().checkReturnDU(v);  }
  protected java.util.Map throwsException_TypeDecl_values;
  /**
   * @attribute syn
   * @aspect ExceptionHandling
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:165
   */

  public boolean throwsException(TypeDecl exceptionType) {
    Object _parameters = exceptionType;
    if(throwsException_TypeDecl_values == null) throwsException_TypeDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(throwsException_TypeDecl_values.containsKey(_parameters)) {
  return ((Boolean)throwsException_TypeDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean throwsException_TypeDecl_value = throwsException_compute(exceptionType);
      if(isFinal && num == state().boundariesCrossed){ throwsException_TypeDecl_values.put(_parameters, Boolean.valueOf(throwsException_TypeDecl_value)); }
        return throwsException_TypeDecl_value;
  }
  /**
   * @apilevel internal
   */
  private boolean throwsException_compute(TypeDecl exceptionType) {
      for(int i = 0; i < getNumException(); i++)
        if(exceptionType.instanceOf(getException(i).type()))
          return true;
      return false;
    }
  /**
   * @apilevel internal
   */
  protected boolean name_computed = false;
  /**
   * @apilevel internal
   */
  protected String name_value;
  /**
   * @attribute syn
   * @aspect ConstructorDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:110
   */

  public String name() {
    

    
if(name_computed) {
  return name_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    name_value = name_compute();
      if(isFinal && num == state().boundariesCrossed){ name_computed = true; }
        return name_value;
  }
  /**
   * @apilevel internal
   */
  private String name_compute() {  return getID();  }
  /**
   * @apilevel internal
   */
  protected boolean signature_computed = false;
  /**
   * @apilevel internal
   */
  protected String signature_value;
  /**
   * @attribute syn
   * @aspect ConstructorDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:112
   */

  public String signature() {
    

    
if(signature_computed) {
  return signature_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    signature_value = signature_compute();
      if(isFinal && num == state().boundariesCrossed){ signature_computed = true; }
        return signature_value;
  }
  /**
   * @apilevel internal
   */
  private String signature_compute() {
      StringBuffer s = new StringBuffer();
      s.append(name() + "(");
      for(int i = 0; i < getNumParameter(); i++) {
        s.append(getParameter(i));
        if(i != getNumParameter() - 1)
          s.append(", ");
      }
      s.append(")");
      return s.toString();
    }
  protected java.util.Map sameSignature_ConstructorDecl_values;
  /**
   * @attribute syn
   * @aspect ConstructorDecl
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:125
   */

  public boolean sameSignature(ConstructorDecl c) {
    Object _parameters = c;
    if(sameSignature_ConstructorDecl_values == null) sameSignature_ConstructorDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(sameSignature_ConstructorDecl_values.containsKey(_parameters)) {
  return ((Boolean)sameSignature_ConstructorDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean sameSignature_ConstructorDecl_value = sameSignature_compute(c);
      if(isFinal && num == state().boundariesCrossed){ sameSignature_ConstructorDecl_values.put(_parameters, Boolean.valueOf(sameSignature_ConstructorDecl_value)); }
        return sameSignature_ConstructorDecl_value;
  }
  /**
   * @apilevel internal
   */
  private boolean sameSignature_compute(ConstructorDecl c) {
      if(!name().equals(c.name()))
        return false;
      if(c.getNumParameter() != getNumParameter())
        return false;
      for(int i = 0; i < getNumParameter(); i++)
        if(!c.getParameter(i).type().equals(getParameter(i).type()))
          return false;
      return true;
    }
  protected java.util.Map moreSpecificThan_ConstructorDecl_values;
  /**
   * @attribute syn
   * @aspect MethodSignature15
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:168
   */

  public boolean moreSpecificThan(ConstructorDecl m) {
    Object _parameters = m;
    if(moreSpecificThan_ConstructorDecl_values == null) moreSpecificThan_ConstructorDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(moreSpecificThan_ConstructorDecl_values.containsKey(_parameters)) {
  return ((Boolean)moreSpecificThan_ConstructorDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean moreSpecificThan_ConstructorDecl_value = moreSpecificThan_compute(m);
      if(isFinal && num == state().boundariesCrossed){ moreSpecificThan_ConstructorDecl_values.put(_parameters, Boolean.valueOf(moreSpecificThan_ConstructorDecl_value)); }
        return moreSpecificThan_ConstructorDecl_value;
  }
  /**
   * @apilevel internal
   */
  private boolean moreSpecificThan_compute(ConstructorDecl m) {
      if(!isVariableArity() && !m.isVariableArity())
        return refined_ConstructorDecl_ConstructorDecl_moreSpecificThan_ConstructorDecl(m);
      int num = Math.max(getNumParameter(), m.getNumParameter());
      for(int i = 0; i < num; i++) {
        TypeDecl t1 = i < getNumParameter() - 1 ? getParameter(i).type() : getParameter(getNumParameter()-1).type().componentType();
        TypeDecl t2 = i < m.getNumParameter() - 1 ? m.getParameter(i).type() : m.getParameter(m.getNumParameter()-1).type().componentType();
        if(!t1.instanceOf(t2))
          return false;
      }
      return true;
    }
    /**
       * @return true if this is an auto-generated default constructor
       
     * @attribute syn
     * @aspect ImplicitConstructor
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:182
     */
  public boolean isDefaultConstructor() {
    ASTNode$State state = state();
    try {  return isDefaultConstructor;  }
    finally {
    }
  }
  protected java.util.Map parameterDeclaration_String_values;
  /**
   * @attribute syn
   * @aspect VariableScope
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:105
   */

  public SimpleSet parameterDeclaration(String name) {
    Object _parameters = name;
    if(parameterDeclaration_String_values == null) parameterDeclaration_String_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(parameterDeclaration_String_values.containsKey(_parameters)) {
  return (SimpleSet)parameterDeclaration_String_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    SimpleSet parameterDeclaration_String_value = parameterDeclaration_compute(name);
      if(isFinal && num == state().boundariesCrossed){ parameterDeclaration_String_values.put(_parameters, parameterDeclaration_String_value); }
        return parameterDeclaration_String_value;
  }
  /**
   * @apilevel internal
   */
  private SimpleSet parameterDeclaration_compute(String name) {
      for(int i = 0; i < getNumParameter(); i++)
        if(getParameter(i).name().equals(name))
          return (ParameterDeclaration)getParameter(i);
      return SimpleSet.emptySet;
    }
    /**
     * @attribute syn
     * @aspect Modifiers
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:217
     */
  public boolean isSynthetic() {
    ASTNode$State state = state();
    try {  return getModifiers().isSynthetic();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Modifiers
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:235
     */
  public boolean isPublic() {
    ASTNode$State state = state();
    try {  return getModifiers().isPublic();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Modifiers
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:236
     */
  public boolean isPrivate() {
    ASTNode$State state = state();
    try {  return getModifiers().isPrivate();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Modifiers
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:237
     */
  public boolean isProtected() {
    ASTNode$State state = state();
    try {  return getModifiers().isProtected();  }
    finally {
    }
  }
  protected java.util.Map circularThisInvocation_ConstructorDecl_values;
  /**
   * @attribute syn
   * @aspect NameCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:108
   */

  @SuppressWarnings({"unchecked", "cast"})
  public boolean circularThisInvocation(ConstructorDecl decl) {
    Object _parameters = decl;
    if(circularThisInvocation_ConstructorDecl_values == null) circularThisInvocation_ConstructorDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    ASTNode$State.CircularValue _value;
    

    
if(circularThisInvocation_ConstructorDecl_values.containsKey(_parameters)) {
  Object _o = circularThisInvocation_ConstructorDecl_values.get(_parameters);
  if(!(_o instanceof ASTNode$State.CircularValue)) {
    return ((Boolean)_o).booleanValue();
  } else { 
    _value = (ASTNode$State.CircularValue)_o;
  }
}
 else {
      _value = new ASTNode$State.CircularValue();
      circularThisInvocation_ConstructorDecl_values.put(_parameters, _value);
      _value.value = Boolean.valueOf(true);
    }
    ASTNode$State state = state();
    if (!state.IN_CIRCLE) {
      state.IN_CIRCLE = true;
      int num = state.boundariesCrossed;
      boolean isFinal = this.is$Final();
      // TODO: fixme
      // state().CIRCLE_INDEX = 1;
      boolean new_circularThisInvocation_ConstructorDecl_value;
      do {
        _value.visited = new Integer(state.CIRCLE_INDEX);
        state.CHANGE = false;
        new_circularThisInvocation_ConstructorDecl_value = circularThisInvocation_compute(decl);
        if (new_circularThisInvocation_ConstructorDecl_value!=((Boolean)_value.value).booleanValue()) {
          state.CHANGE = true;
          _value.value = Boolean.valueOf(new_circularThisInvocation_ConstructorDecl_value);
        }
        state.CIRCLE_INDEX++;
      } while (state.CHANGE);
        if(isFinal && num == state().boundariesCrossed) {
        circularThisInvocation_ConstructorDecl_values.put(_parameters, new_circularThisInvocation_ConstructorDecl_value);
      } else {
        circularThisInvocation_ConstructorDecl_values.remove(_parameters);
        state.RESET_CYCLE = true;
circularThisInvocation_compute(decl);
state.RESET_CYCLE = false;
      }
      state.IN_CIRCLE = false;
      return new_circularThisInvocation_ConstructorDecl_value;
    }
    if (!new Integer(state.CIRCLE_INDEX).equals(_value.visited)) {
      _value.visited = new Integer(state.CIRCLE_INDEX);
      boolean new_circularThisInvocation_ConstructorDecl_value = circularThisInvocation_compute(decl);
      if (state.RESET_CYCLE) {
        circularThisInvocation_ConstructorDecl_values.remove(_parameters);
      }
      else if (new_circularThisInvocation_ConstructorDecl_value!=((Boolean)_value.value).booleanValue()) {
        state.CHANGE = true;
        _value.value = new_circularThisInvocation_ConstructorDecl_value;
      }
      return new_circularThisInvocation_ConstructorDecl_value;
    }
    return ((Boolean)_value.value).booleanValue();
  }
  /**
   * @apilevel internal
   */
  private boolean circularThisInvocation_compute(ConstructorDecl decl) {
      if(hasConstructorInvocation()) {
        Expr e = ((ExprStmt)getConstructorInvocation()).getExpr();
        if(e instanceof ConstructorAccess) {
          ConstructorDecl constructorDecl = ((ConstructorAccess)e).decl();
          if(constructorDecl == decl)
            return true;
          return constructorDecl.circularThisInvocation(decl);
        }
      }
      return false;
    }
    /**
     * @attribute syn
     * @aspect TypeAnalysis
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:268
     */
  public TypeDecl type() {
    ASTNode$State state = state();
    try {  return unknownType();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect TypeAnalysis
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:271
     */
  public boolean isVoid() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean attributes_computed = false;
  /**
   * @apilevel internal
   */
  protected Collection attributes_value;
  /**
   * @attribute syn
   * @aspect AnnotationsCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/AnnotationsCodegen.jrag:31
   */

  public Collection attributes() {
    

    
if(attributes_computed) {
  return attributes_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    attributes_value = attributes_compute();
      if(isFinal && num == state().boundariesCrossed){ attributes_computed = true; }
        return attributes_value;
  }
  /**
   * @apilevel internal
   */
  private Collection attributes_compute() {
      Collection c = refined_Attributes_ConstructorDecl_attributes();
      getModifiers().addRuntimeVisibleAnnotationsAttribute(c);
      getModifiers().addRuntimeInvisibleAnnotationsAttribute(c);
      return c;
    }
  /**
   * @apilevel internal
   */
  protected boolean descName_computed = false;
  /**
   * @apilevel internal
   */
  protected String descName_value;
  /**
   * @attribute syn
   * @aspect ConstantPoolNames
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/ConstantPoolNames.jrag:48
   */

  public String descName() {
    

    
if(descName_computed) {
  return descName_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    descName_value = descName_compute();
      if(isFinal && num == state().boundariesCrossed){ descName_computed = true; }
        return descName_value;
  }
  /**
   * @apilevel internal
   */
  private String descName_compute() {
      StringBuffer b = new StringBuffer();
      b.append("(");
      // this$0
      if(needsEnclosing())
        b.append(enclosing().typeDescriptor());
      if(needsSuperEnclosing())
        b.append(superEnclosing().typeDescriptor());
      // args
      for (int i=0; i<getNumParameter(); i++)
        b.append(getParameter(i).type().typeDescriptor());
      b.append(")V");
      return b.toString();
    }
  protected java.util.Map bytecodes_ConstantPool_values;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:122
   */

  public CodeGeneration bytecodes(ConstantPool constantPool) {
    Object _parameters = constantPool;
    if(bytecodes_ConstantPool_values == null) bytecodes_ConstantPool_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(bytecodes_ConstantPool_values.containsKey(_parameters)) {
  return (CodeGeneration)bytecodes_ConstantPool_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    CodeGeneration bytecodes_ConstantPool_value = bytecodes_compute(constantPool);
      if(isFinal && num == state().boundariesCrossed){ bytecodes_ConstantPool_values.put(_parameters, bytecodes_ConstantPool_value); }
        return bytecodes_ConstantPool_value;
  }
  /**
   * @apilevel internal
   */
  private CodeGeneration bytecodes_compute(ConstantPool constantPool) {
      CodeGeneration gen = new CodeGeneration(constantPool);
      generateBytecodes(gen);
      if(!gen.numberFormatError())
        return gen;
      gen = new CodeGeneration(constantPool, true);
      generateBytecodes(gen);
      if(!gen.numberFormatError())
        return gen;
      throw new Error("Could not generate code for " + signature() + " in " + hostType().typeName());
    }
  /**
   * @apilevel internal
   */
  protected boolean flags_computed = false;
  /**
   * @apilevel internal
   */
  protected int flags_value;
  /**
   * @attribute syn
   * @aspect VariableArityParametersCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/VariableArityParametersCodegen.jrag:94
   */

  public int flags() {
    

    
if(flags_computed) {
  return flags_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    flags_value = flags_compute();
      if(isFinal && num == state().boundariesCrossed){ flags_computed = true; }
        return flags_value;
  }
  /**
   * @apilevel internal
   */
  private int flags_compute() {
      int res = refined_Flags_ConstructorDecl_flags();
      if(isVariableArity())
        res |= Modifiers.ACC_VARARGS;
      return res;
    }
    /**
     * @attribute syn
     * @aspect GenerateClassfile
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/GenerateClassfile.jrag:296
     */
  public boolean isBytecodeMethod() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect GenerateClassfile
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/GenerateClassfile.jrag:325
     */
  public boolean flush() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:433
     */
  public boolean needsEnclosing() {
    ASTNode$State state = state();
    try {  return hostType().needsEnclosing();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:434
     */
  public boolean needsSuperEnclosing() {
    ASTNode$State state = state();
    try {  return hostType().needsSuperEnclosing();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:436
     */
  public TypeDecl enclosing() {
    ASTNode$State state = state();
    try {  return hostType().enclosing();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:437
     */
  public TypeDecl superEnclosing() {
    ASTNode$State state = state();
    try {  return hostType().superEnclosing();  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean localNumOfFirstParameter_computed = false;
  /**
   * @apilevel internal
   */
  protected int localNumOfFirstParameter_value;
  /**
   * @attribute syn
   * @aspect LocalNum
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:61
   */

  public int localNumOfFirstParameter() {
    

    
if(localNumOfFirstParameter_computed) {
  return localNumOfFirstParameter_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    localNumOfFirstParameter_value = localNumOfFirstParameter_compute();
      if(isFinal && num == state().boundariesCrossed){ localNumOfFirstParameter_computed = true; }
        return localNumOfFirstParameter_value;
  }
  /**
   * @apilevel internal
   */
  private int localNumOfFirstParameter_compute() {
      int i = 1;
      if(hostType().needsEnclosing())
        i++;
      if(hostType().needsSuperEnclosing())
        i++;
      return i;
    }
  /**
   * @apilevel internal
   */
  protected boolean offsetFirstEnclosingVariable_computed = false;
  /**
   * @apilevel internal
   */
  protected int offsetFirstEnclosingVariable_value;
  /**
   * @attribute syn
   * @aspect LocalNum
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:70
   */

  public int offsetFirstEnclosingVariable() {
    

    
if(offsetFirstEnclosingVariable_computed) {
  return offsetFirstEnclosingVariable_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    offsetFirstEnclosingVariable_value = offsetFirstEnclosingVariable_compute();
      if(isFinal && num == state().boundariesCrossed){ offsetFirstEnclosingVariable_computed = true; }
        return offsetFirstEnclosingVariable_value;
  }
  /**
   * @apilevel internal
   */
  private int offsetFirstEnclosingVariable_compute() {
      int localIndex = localNumOfFirstParameter();
      Collection vars = hostType().enclosingVariables();
      if(vars.isEmpty())
        return localIndex;
      String name = "val$" + ((Variable)vars.iterator().next()).name();
      for(int i = 0; !getParameter(i).name().equals(name); i++)
        localIndex += getParameter(i).type().variableSize();
      return localIndex;
    }
    /**
     * @attribute syn
     * @aspect LocalNum
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:81
     */
  public int localIndexOfEnclosingVariable(Variable v) {
    ASTNode$State state = state();
    try {
        int localIndex  = offsetFirstEnclosingVariable();
        Iterator iter = hostType().enclosingVariables().iterator();
        Variable varDecl = (Variable)iter.next();
        while(varDecl != v && iter.hasNext()) {
          localIndex += varDecl.type().variableSize();
          varDecl = (Variable)iter.next();
        }
        return localIndex;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Annotations
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Annotations.jrag:283
     */
  public boolean hasAnnotationSuppressWarnings(String s) {
    ASTNode$State state = state();
    try {  return getModifiers().hasAnnotationSuppressWarnings(s);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect Annotations
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Annotations.jrag:324
     */
  public boolean isDeprecated() {
    ASTNode$State state = state();
    try {  return getModifiers().hasDeprecatedAnnotation();  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean sourceConstructorDecl_computed = false;
  /**
   * @apilevel internal
   */
  protected ConstructorDecl sourceConstructorDecl_value;
  /**
   * @attribute syn
   * @aspect SourceDeclarations
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:1515
   */

  public ConstructorDecl sourceConstructorDecl() {
    

    
if(sourceConstructorDecl_computed) {
  return sourceConstructorDecl_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    sourceConstructorDecl_value = sourceConstructorDecl_compute();
      if(isFinal && num == state().boundariesCrossed){ sourceConstructorDecl_computed = true; }
        return sourceConstructorDecl_value;
  }
  /**
   * @apilevel internal
   */
  private ConstructorDecl sourceConstructorDecl_compute() {  return this;  }
    /**
     * @attribute syn
     * @aspect MethodSignature15
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:190
     */
  public boolean applicableBySubtyping(List argList) {
    ASTNode$State state = state();
    try {
        if(getNumParameter() != argList.getNumChild())
          return false;
        for(int i = 0; i < getNumParameter(); i++) {
          TypeDecl arg = ((Expr)argList.getChild(i)).type();
          if(!arg.instanceOf(getParameter(i).type()))
            return false;
        }
        return true;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect MethodSignature15
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:210
     */
  public boolean applicableByMethodInvocationConversion(List argList) {
    ASTNode$State state = state();
    try {
        if(getNumParameter() != argList.getNumChild())
          return false;
        for(int i = 0; i < getNumParameter(); i++) {
          TypeDecl arg = ((Expr)argList.getChild(i)).type();
          if(!arg.methodInvocationConversionTo(getParameter(i).type()))
            return false;
        }
        return true;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect MethodSignature15
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:231
     */
  public boolean applicableVariableArity(List argList) {
    ASTNode$State state = state();
    try {
        for(int i = 0; i < getNumParameter() - 1; i++) {
          TypeDecl arg = ((Expr)argList.getChild(i)).type();
          if(!arg.methodInvocationConversionTo(getParameter(i).type()))
            return false;
        }
        for(int i = getNumParameter() - 1; i < argList.getNumChild(); i++) {
          TypeDecl arg = ((Expr)argList.getChild(i)).type();
          if(!arg.methodInvocationConversionTo(lastParameter().type().componentType()))
            return false;
        }
        return true;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect MethodSignature15
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:318
     */
  public boolean potentiallyApplicable(List argList) {
    ASTNode$State state = state();
    try {
        if(isVariableArity() && !(argList.getNumChild() >= arity()-1))
          return false;
        if(!isVariableArity() && !(arity() == argList.getNumChild()))
          return false;
        return true;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect MethodSignature15
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/MethodSignature.jrag:325
     */
  public int arity() {
    ASTNode$State state = state();
    try {  return getNumParameter();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect VariableArityParameters
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/VariableArityParameters.jrag:34
     */
  public boolean isVariableArity() {
    ASTNode$State state = state();
    try {  return getNumParameter() == 0 ? false : getParameter(getNumParameter()-1).isVariableArity();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect VariableArityParameters
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/VariableArityParameters.jrag:63
     */
  public ParameterDeclaration lastParameter() {
    ASTNode$State state = state();
    try {  return getParameter(getNumParameter() - 1);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect GenericsCodegen
     * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/GenericsCodegen.jrag:168
     */
  public ConstructorDecl erasedConstructor() {
    ASTNode$State state = state();
    try {  return this;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect GenericsCodegen
     * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/GenericsCodegen.jrag:373
     */
  public boolean needsSignatureAttribute() {
    ASTNode$State state = state();
    try {
        for(int i = 0; i < getNumParameter(); i++)
          if(getParameter(i).type().needsSignatureAttribute())
            return true;
        return false;
      }
    finally {
    }
  }
    /**
       * @return true if the modifier list includes the SafeVarargs annotation
       
     * @attribute syn
     * @aspect SafeVarargs
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/SafeVarargs.jrag:20
     */
  public boolean hasAnnotationSafeVarargs() {
    ASTNode$State state = state();
    try {  return getModifiers().hasAnnotationSafeVarargs();  }
    finally {
    }
  }
    /**
       * It is an error if the SafeVarargs annotation is used on something
       * that is not a variable arity method or constructor.
       
     * @attribute syn
     * @aspect SafeVarargs
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/SafeVarargs.jrag:56
     */
  public boolean hasIllegalAnnotationSafeVarargs() {
    ASTNode$State state = state();
    try {  return hasAnnotationSafeVarargs() && !isVariableArity();  }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect ExceptionHandling
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:56
   */

  public boolean handlesException(TypeDecl exceptionType) {
    Object _parameters = exceptionType;
    if(handlesException_TypeDecl_values == null) handlesException_TypeDecl_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(handlesException_TypeDecl_values.containsKey(_parameters)) {
  return ((Boolean)handlesException_TypeDecl_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean handlesException_TypeDecl_value = getParent().Define_boolean_handlesException(this, null, exceptionType);
      if(isFinal && num == state().boundariesCrossed){ handlesException_TypeDecl_values.put(_parameters, Boolean.valueOf(handlesException_TypeDecl_value)); }
        return handlesException_TypeDecl_value;
  }
  protected java.util.Map handlesException_TypeDecl_values;
  /**
   * @attribute inh
   * @aspect TypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:267
   */

  public TypeDecl unknownType() {
    ASTNode$State state = state();
    TypeDecl unknownType_value = getParent().Define_TypeDecl_unknownType(this, null);
        return unknownType_value;
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:298
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getBlockNoTransform()) {
      return hasConstructorInvocation() ? getConstructorInvocation().isDAafter(v) : isDAbefore(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:755
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getBlockNoTransform()) {
      return hasConstructorInvocation() ? getConstructorInvocation().isDUafter(v) : isDUbefore(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ExceptionHandling.jrag:162
   * @apilevel internal
   */
  public boolean Define_boolean_handlesException(ASTNode caller, ASTNode child, TypeDecl exceptionType) {
    if(caller == getConstructorInvocationOptNoTransform()) {
      return throwsException(exceptionType) || handlesException(exceptionType);
    }
    else if(caller == getBlockNoTransform()) {
      return throwsException(exceptionType) || handlesException(exceptionType);
    }
    else {      return getParent().Define_boolean_handlesException(this, caller, exceptionType);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupMethod.jrag:45
   * @apilevel internal
   */
  public Collection Define_Collection_lookupMethod(ASTNode caller, ASTNode child, String name) {
    if(caller == getConstructorInvocationOptNoTransform()){
    Collection c = new ArrayList();
    for(Iterator iter = lookupMethod(name).iterator(); iter.hasNext(); ) {
      MethodDecl m = (MethodDecl)iter.next();
      if(!hostType().memberMethods(name).contains(m) || m.isStatic())
        c.add(m);
    }
    return c;
  }
    else {      return getParent().Define_Collection_lookupMethod(this, caller, name);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:64
   * @apilevel internal
   */
  public SimpleSet Define_SimpleSet_lookupVariable(ASTNode caller, ASTNode child, String name) {
    if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return parameterDeclaration(name);
  }
    else if(caller == getConstructorInvocationOptNoTransform()){
    SimpleSet set = parameterDeclaration(name);
    if(!set.isEmpty()) return set;
    for(Iterator iter = lookupVariable(name).iterator(); iter.hasNext(); ) {
      Variable v = (Variable)iter.next();
      if(!hostType().memberFields(name).contains(v) || v.isStatic())
        set = set.add(v);
    }
    return set;
  }
    else if(caller == getBlockNoTransform()){
    SimpleSet set = parameterDeclaration(name);
    if(!set.isEmpty()) return set;
    return lookupVariable(name);
  }
    else {      return getParent().Define_SimpleSet_lookupVariable(this, caller, name);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:282
   * @apilevel internal
   */
  public boolean Define_boolean_mayBePublic(ASTNode caller, ASTNode child) {
    if(caller == getModifiersNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_mayBePublic(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:283
   * @apilevel internal
   */
  public boolean Define_boolean_mayBeProtected(ASTNode caller, ASTNode child) {
    if(caller == getModifiersNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_mayBeProtected(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/Modifiers.jrag:284
   * @apilevel internal
   */
  public boolean Define_boolean_mayBePrivate(ASTNode caller, ASTNode child) {
    if(caller == getModifiersNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_mayBePrivate(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:268
   * @apilevel internal
   */
  public ASTNode Define_ASTNode_enclosingBlock(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return this;
    }
    else {      return getParent().Define_ASTNode_enclosingBlock(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/SyntacticClassification.jrag:117
   * @apilevel internal
   */
  public NameType Define_NameType_nameType(ASTNode caller, ASTNode child) {
    if(caller == getConstructorInvocationOptNoTransform()) {
      return NameType.EXPRESSION_NAME;
    }
    else if(caller == getExceptionListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return NameType.TYPE_NAME;
  }
    else if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return NameType.TYPE_NAME;
  }
    else {      return getParent().Define_NameType_nameType(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:518
   * @apilevel internal
   */
  public TypeDecl Define_TypeDecl_enclosingInstance(ASTNode caller, ASTNode child) {
    if(caller == getConstructorInvocationOptNoTransform()) {
      return unknownType();
    }
    else {      return getParent().Define_TypeDecl_enclosingInstance(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeHierarchyCheck.jrag:132
   * @apilevel internal
   */
  public boolean Define_boolean_inExplicitConstructorInvocation(ASTNode caller, ASTNode child) {
    if(caller == getConstructorInvocationOptNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_inExplicitConstructorInvocation(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeHierarchyCheck.jrag:144
   * @apilevel internal
   */
  public boolean Define_boolean_inStaticContext(ASTNode caller, ASTNode child) {
    if(caller == getConstructorInvocationOptNoTransform()) {
      return false;
    }
    else if(caller == getBlockNoTransform()) {
      return false;
    }
    else {      return getParent().Define_boolean_inStaticContext(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:32
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return !hasConstructorInvocation() ? true : getConstructorInvocation().canCompleteNormally();
    }
    else if(caller == getConstructorInvocationOptNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/VariableDeclaration.jrag:58
   * @apilevel internal
   */
  public boolean Define_boolean_isMethodParameter(ASTNode caller, ASTNode child) {
    if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return false;
  }
    else {      return getParent().Define_boolean_isMethodParameter(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/VariableDeclaration.jrag:59
   * @apilevel internal
   */
  public boolean Define_boolean_isConstructorParameter(ASTNode caller, ASTNode child) {
    if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return true;
  }
    else {      return getParent().Define_boolean_isConstructorParameter(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/VariableDeclaration.jrag:60
   * @apilevel internal
   */
  public boolean Define_boolean_isExceptionHandlerParameter(ASTNode caller, ASTNode child) {
    if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return false;
  }
    else {      return getParent().Define_boolean_isExceptionHandlerParameter(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:96
   * @apilevel internal
   */
  public int Define_int_localNum(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return getNumParameter() == 0 ?
    localNumOfFirstParameter() :
    getParameter(getNumParameter()-1).localNum() + getParameter(getNumParameter()-1).type().variableSize();
    }
    else if(caller == getParameterListNoTransform())  {
    int index = caller.getIndexOfChild(child);
    return index == 0 ?
    localNumOfFirstParameter() :
    getParameter(index-1).localNum() + getParameter(index-1).type().variableSize();
  }
    else {      return getParent().Define_int_localNum(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Annotations.jrag:89
   * @apilevel internal
   */
  public boolean Define_boolean_mayUseAnnotationTarget(ASTNode caller, ASTNode child, String name) {
    if(caller == getModifiersNoTransform()) {
      return name.equals("CONSTRUCTOR");
    }
    else {      return getParent().Define_boolean_mayUseAnnotationTarget(this, caller, name);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/VariableArityParameters.jrag:21
   * @apilevel internal
   */
  public boolean Define_boolean_variableArityValid(ASTNode caller, ASTNode child) {
    if(caller == getParameterListNoTransform())  {
    int i = caller.getIndexOfChild(child);
    return i == getNumParameter() - 1;
  }
    else {      return getParent().Define_boolean_variableArityValid(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:48
   * @apilevel internal
   */
  public boolean Define_boolean_inhModifiedInScope(ASTNode caller, ASTNode child, Variable var) {
    if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return getBlock().modifiedInScope(var);
  }
    else {      return getParent().Define_boolean_inhModifiedInScope(this, caller, var);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:123
   * @apilevel internal
   */
  public boolean Define_boolean_isCatchParam(ASTNode caller, ASTNode child) {
    if(caller == getParameterListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return false;
  }
    else {      return getParent().Define_boolean_isCatchParam(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    // Declared at @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:218
    if (!hasConstructorInvocation() && !hostType().isObject()) {
      state().duringImplicitConstructor++;
      ASTNode result = rewriteRule0();
      state().duringImplicitConstructor--;
      return result;
    }    return super.rewriteTo();
  }  /**
   * @declaredat @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupConstructor.jrag:218
   * @apilevel internal
   */  private ConstructorDecl rewriteRule0() {
{
      setConstructorInvocation(
        new ExprStmt(
          new SuperConstructorAccess("super", new List())
          )
        );
      return this;
    }  }
}
