/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * Java floating point literal. Can store any value representable as an
 * IEEE 754 32-bit single-precision floating point number.
 * @production FloatingPointLiteral : {@link NumericLiteral};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java7/grammar/Literals.ast:60
 */
public class FloatingPointLiteral extends NumericLiteral implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public FloatingPointLiteral clone() throws CloneNotSupportedException {
    FloatingPointLiteral node = (FloatingPointLiteral) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public FloatingPointLiteral copy() {
    try {
      FloatingPointLiteral node = (FloatingPointLiteral) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public FloatingPointLiteral fullCopy() {
    FloatingPointLiteral tree = (FloatingPointLiteral) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:582
   */

  public void typeCheck() {
   if(!isZero() && constant().floatValue() == 0.0f)
     error("It is an error for nonzero floating-point " + getLITERAL() + " to round to zero");
   if(constant().floatValue() == Float.NEGATIVE_INFINITY || constant().floatValue() == Float.POSITIVE_INFINITY)
     error("It is an error for floating-point " + getLITERAL() + " to round to an infinity");

 }
  /**
   * 
   * @ast method
   * @aspect CodeGeneration
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:116
   */

  public static void push(CodeGeneration gen, float value) {
    if(value == 0)
      gen.emit(Bytecode.FCONST_0);
    else if(value == 1)
      gen.emit(Bytecode.FCONST_1);
    else if(value == 2)
      gen.emit(Bytecode.FCONST_2);
    else {
      int index = gen.constantPool().addConstant(value);
      if(index < 256)
        gen.emit(Bytecode.LDC).add(index);
      else
        gen.emit(Bytecode.LDC_W).add2(index);
    }
  }
  /**
   * 
   * @ast method
   * @aspect CodeGeneration
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:163
   */

  public void emitPushConstant(CodeGeneration gen) {
    FloatingPointLiteral.push(gen, constant().floatValue());
  }
  /**
   * 
   * @ast method
   * 
   */

  public FloatingPointLiteral() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
  }
  /**
   * 
   * @ast method
   * 
   */

  public FloatingPointLiteral(String p0) {
    setLITERAL(p0);
  }
  /**
   * 
   * @ast method
   * 
   */

  public FloatingPointLiteral(beaver.Symbol p0) {
    setLITERAL(p0);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 0;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return true;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        type_computed = false;
    type_value = null;
    isZero_computed = false;
    constant_computed = false;
    constant_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the lexeme LITERAL.
     * @param value The new value for the lexeme LITERAL.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setLITERAL(String value) {
    tokenString_LITERAL = value;
  }
  /**
   * 
     * JastAdd-internal setter for lexeme LITERAL using the Beaver parser.
     * @param symbol Symbol containing the new value for the lexeme LITERAL
     * @apilevel internal
     
   * @ast method
   * 
   */

  public void setLITERAL(beaver.Symbol symbol) {
    if(symbol.value != null && !(symbol.value instanceof String))
    throw new UnsupportedOperationException("setLITERAL is only valid for String lexemes");
    tokenString_LITERAL = (String)symbol.value;
    LITERALstart = symbol.getStart();
    LITERALend = symbol.getEnd();
  }
  /**
   * 
     * Retrieves the value for the lexeme LITERAL.
     * @return The value for the lexeme LITERAL.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public String getLITERAL() {
    return tokenString_LITERAL != null ? tokenString_LITERAL : "";
  }
  /**
   * 
     * Defer pretty printing to superclass.
     
   * @ast method
   * @aspect Java7Literals
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/JDimeLiterals.jrag:29
   */

    public void prettyPrint(StringBuffer s) {
    super.prettyPrint(s);
  }
  /**
   * 
     * Defer pretty printing to superclass.
     
   * @ast method
   * @aspect Java7Literals
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/Literals.jrag:105
   */

    public void toString(StringBuffer s) {
    super.toString(s);
  }
  /**
   * @apilevel internal
   */
  protected boolean type_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl type_value;
  /**
   * @attribute syn
   * @aspect TypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:302
   */

  public TypeDecl type() {
    

    
if(type_computed) {
  return type_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    type_value = type_compute();
      if(isFinal && num == state().boundariesCrossed){ type_computed = true; }
        return type_value;
  }
  /**
   * @apilevel internal
   */
  private TypeDecl type_compute() {  return typeFloat();  }
  /**
   * @apilevel internal
   */
  protected boolean isZero_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean isZero_value;
  /**
     * @return true if this floating point literal is equivalent to a zero literal
     
   * @attribute syn
   * @aspect Java7Literals
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/Literals.jrag:22
   */

  public boolean isZero() {
    

    
if(isZero_computed) {
  return isZero_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    isZero_value = isZero_compute();
      if(isFinal && num == state().boundariesCrossed){ isZero_computed = true; }
        return isZero_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isZero_compute() {
      for(int i = 0; i < digits.length(); i++) {
        char c = digits.charAt(i);
        if (c == 'e' || c == 'p') break;
        if (c != '0' && c != '.') {
          return false;
        }
      }
      return true;
    }
  /**
   * @apilevel internal
   */
  protected boolean constant_computed = false;
  /**
   * @apilevel internal
   */
  protected Constant constant_value;
  /**
     * Parse this literal and return a fresh Constant.
     * @return a fresh Constant representing this FloatingPointLiteral
     
   * @attribute syn
   * @aspect Java7Literals
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/Literals.jrag:175
   */

  public Constant constant() {
    

    
if(constant_computed) {
  return constant_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    constant_value = constant_compute();
      if(isFinal && num == state().boundariesCrossed){ constant_computed = true; }
        return constant_value;
  }
  /**
   * @apilevel internal
   */
  private Constant constant_compute() {
      try {
        return Constant.create(Float.parseFloat(getDigits()));
      }
      catch (NumberFormatException e) {
        Constant c = Constant.create(0.0f);
        c.error = true;
        return c;
      }
    }
    /**
       * Utility attribute for literal rewriting.
       * Any of the NumericLiteral subclasses have already
       * been rewritten and/or parsed, and should not be
       * rewritten again.
       *
       * @return true if this literal is a "raw", not-yet-parsed NumericLiteral
       
     * @attribute syn
     * @aspect Java7Literals
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/Literals.jrag:334
     */
  public boolean needsRewrite() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
