/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * Used in code generation to represent the implicit monitor exit
 * call at the end of a synchronized block.
 * @production MonitorExit : {@link Block};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:221
 */
public class MonitorExit extends Block implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public MonitorExit clone() throws CloneNotSupportedException {
    MonitorExit node = (MonitorExit) super.clone();
    node.handler_label_computed = false;
    node.handler_end_label_computed = false;
    node.end_label_computed = false;
    node.in$Circle(false);
    node.is$Final(false);
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public MonitorExit copy() {
    try {
      MonitorExit node = (MonitorExit) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public MonitorExit fullCopy() {
    MonitorExit tree = (MonitorExit) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect MonitorExit
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/MonitorExit.jrag:14
   */

  

  protected SynchronizedStmt monitor = null;
  /**
   * 
   * @ast method
   * @aspect MonitorExit
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/MonitorExit.jrag:16
   */

  public MonitorExit(SynchronizedStmt sync) {
    monitor = sync;
  }
  /**
   * 
     * Generate bytecode for the monitor exit call.
     
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1729
   */

  public void createBCode(CodeGeneration gen) {
    gen.monitorRangeEnd(monitor.monitorId,
        hostType().constantPool().newLabel());
  }
  /**
   * 
     * Generate exception handler for monitor closing.
     * @param gen
     
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1738
   */

  public void emitMonitorExitHandler(CodeGeneration gen) {
    int handler_lbl = handler_label();
    int end_lbl = handler_end_label();

    gen.changeStackDepth(1);
    int num = localNum() + 1;

    // handler start
    gen.addLabel(handler_lbl);

    gen.emitStoreReference(num);

    gen.emitLoadReference(monitor.localNum());
    gen.emit(Bytecode.MONITOREXIT);

    // handler end
    gen.addLabel(end_lbl);

    gen.emitLoadReference(num);
    gen.emit(Bytecode.ATHROW);

    // add exception handler for the monitor closing
    // http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=4414101
    gen.addException(handler_lbl, end_lbl, handler_lbl,
        CodeGeneration.ExceptionEntry.CATCH_ALL);

  }
  /**
   * 
   * @ast method
   * 
   */

  public MonitorExit() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[1];
    setChild(new List(), 0);
  }
  /**
   * 
   * @ast method
   * 
   */

  public MonitorExit(List<Stmt> p0) {
    setChild(p0, 0);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 1;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        handler_label_computed = false;
    handler_end_label_computed = false;
    end_label_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Stmt list.
     * @param list The new list node to be used as the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setStmtList(List<Stmt> list) {
    setChild(list, 0);
  }
  /**
   * 
     * Retrieves the number of children in the Stmt list.
     * @return Number of children in the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumStmt() {
    return getStmtList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the Stmt list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the Stmt list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumStmtNoTransform() {
    return getStmtListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the Stmt list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Stmt getStmt(int i) {
    return (Stmt) getStmtList().getChild(i);
  }
  /**
   * 
     * Append an element to the Stmt list.
     * @param node The element to append to the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addStmt(Stmt node) {
    List<Stmt> list = (parent == null || state == null) ? getStmtListNoTransform() : getStmtList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addStmtNoTransform(Stmt node) {
    List<Stmt> list = getStmtListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the Stmt list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setStmt(Stmt node, int i) {
    List<Stmt> list = getStmtList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the Stmt list.
     * @return The node representing the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Stmt> getStmtList() {
    List<Stmt> list = (List<Stmt>) getChild(0);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the Stmt list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Stmt list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Stmt> getStmtListNoTransform() {
    return (List<Stmt>) getChildNoTransform(0);
  }
  /**
   * 
     * Retrieves the Stmt list.
     * @return The node representing the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<Stmt> getStmts() {
    return getStmtList();
  }
  /**
   * 
     * Retrieves the Stmt list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Stmt list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<Stmt> getStmtsNoTransform() {
    return getStmtListNoTransform();
  }
  /**
   * @apilevel internal
   */
  protected boolean handler_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int handler_label_value;
  /**
   * @attribute syn
   * @aspect MonitorExit
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/MonitorExit.jrag:11
   */

  public int handler_label() {
    

    
if(handler_label_computed) {
  return handler_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    handler_label_value = handler_label_compute();
      if(isFinal && num == state().boundariesCrossed){ handler_label_computed = true; }
        return handler_label_value;
  }
  /**
   * @apilevel internal
   */
  private int handler_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean handler_end_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int handler_end_label_value;
  /**
   * @attribute syn
   * @aspect MonitorExit
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/MonitorExit.jrag:13
   */

  public int handler_end_label() {
    

    
if(handler_end_label_computed) {
  return handler_end_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    handler_end_label_value = handler_end_label_compute();
      if(isFinal && num == state().boundariesCrossed){ handler_end_label_computed = true; }
        return handler_end_label_value;
  }
  /**
   * @apilevel internal
   */
  private int handler_end_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean end_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int end_label_value;
  /**
   * @attribute syn
   * @aspect MonitorExit
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/MonitorExit.jrag:15
   */

  public int end_label() {
    

    
if(end_label_computed) {
  return end_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    end_label_value = end_label_compute();
      if(isFinal && num == state().boundariesCrossed){ end_label_computed = true; }
        return end_label_value;
  }
  /**
   * @apilevel internal
   */
  private int end_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
