/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;

/**
 * @production ParTypeAccess : {@link Access} ::= <span class="component">TypeAccess:{@link Access}</span> <span class="component">TypeArgument:{@link Access}*</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java5/grammar/Generics.ast:16
 */
public class ParTypeAccess extends Access implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ParTypeAccess clone() throws CloneNotSupportedException {
    ParTypeAccess node = (ParTypeAccess) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ParTypeAccess copy() {
    try {
      ParTypeAccess node = (ParTypeAccess) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ParTypeAccess fullCopy() {
    ParTypeAccess tree = (ParTypeAccess) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect GenericsTypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:336
   */

  public boolean isRaw() {
    return false;
  }
  /**
   * 
   * @ast method
   * @aspect GenericsTypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:444
   */

  public void typeCheck() {
    super.typeCheck();
    if(!genericDecl().isUnknown()) {
      TypeDecl type = type();
      if(!genericDecl().isGenericType()) {
        error(genericDecl().typeName() + " is not a generic type but used as one in " + this);
      }
      else if(!type.isRawType() && type.isNestedType() && type.enclosingType().isRawType())
        error("Can not access a member type of a raw type as a parameterized type");
      else {
        GenericTypeDecl decl = (GenericTypeDecl)genericDecl();
        GenericTypeDecl original = (GenericTypeDecl)decl.original();
        if(original.getNumTypeParameter() != getNumTypeArgument()) {
          error(decl.typeName() + " takes " + original.getNumTypeParameter() + " type parameters, not " + getNumTypeArgument() + " as used in " + this);
        }
        else {
          ParTypeDecl typeDecl = (ParTypeDecl)type();
          for(int i = 0; i < getNumTypeArgument(); i++) {
            if(!getTypeArgument(i).type().instanceOf(original.getTypeParameter(i))) {
              error("type argument " + i + " is of type " + getTypeArgument(i).type().typeName()
                  + " which is not a subtype of " + original.getTypeParameter(i).typeName());
            }
          }
        }
      }
    }
  }
  /**
   * 
   * @ast method
   * @aspect GenericsPrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/GenericsPrettyPrint.jrag:23
   */

  public void toString(StringBuffer s) {
    getTypeAccess().toString(s);
    s.append("<");
    for(int i = 0; i < getNumTypeArgument(); i++) {
      if(i != 0)
        s.append(", ");
      getTypeArgument(i).toString(s);
    }
    s.append(">");
  }
  /**
   * 
   * @ast method
   * @aspect JDimeGenericsPrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/JDimeGenericsPrettyPrint.jrag:26
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;

    getTypeAccess().prettyPrint(s);
    s.append("<");
    for(int i = 0; i < getNumTypeArgument(); i++) {
      if(i != 0)
        s.append(", ");
      getTypeArgument(i).prettyPrint(s);
    }
    s.append(">");
  }
  /**
   * 
   * @ast method
   * 
   */

  public ParTypeAccess() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
    setChild(new List(), 1);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ParTypeAccess(Access p0, List<Access> p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        type_computed = false;
    type_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the TypeAccess child.
     * @param node The new node to replace the TypeAccess child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeAccess(Access node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the TypeAccess child.
     * @return The current node used as the TypeAccess child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Access getTypeAccess() {
    return (Access) getChild(0);
  }
  /**
   * 
     * Retrieves the TypeAccess child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the TypeAccess child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Access getTypeAccessNoTransform() {
    return (Access) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the TypeArgument list.
     * @param list The new list node to be used as the TypeArgument list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeArgumentList(List<Access> list) {
    setChild(list, 1);
  }
  /**
   * 
     * Retrieves the number of children in the TypeArgument list.
     * @return Number of children in the TypeArgument list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumTypeArgument() {
    return getTypeArgumentList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the TypeArgument list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the TypeArgument list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumTypeArgumentNoTransform() {
    return getTypeArgumentListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the TypeArgument list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the TypeArgument list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Access getTypeArgument(int i) {
    return (Access) getTypeArgumentList().getChild(i);
  }
  /**
   * 
     * Append an element to the TypeArgument list.
     * @param node The element to append to the TypeArgument list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addTypeArgument(Access node) {
    List<Access> list = (parent == null || state == null) ? getTypeArgumentListNoTransform() : getTypeArgumentList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addTypeArgumentNoTransform(Access node) {
    List<Access> list = getTypeArgumentListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the TypeArgument list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setTypeArgument(Access node, int i) {
    List<Access> list = getTypeArgumentList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the TypeArgument list.
     * @return The node representing the TypeArgument list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Access> getTypeArgumentList() {
    List<Access> list = (List<Access>) getChild(1);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the TypeArgument list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the TypeArgument list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Access> getTypeArgumentListNoTransform() {
    return (List<Access>) getChildNoTransform(1);
  }
  /**
   * 
     * Retrieves the TypeArgument list.
     * @return The node representing the TypeArgument list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<Access> getTypeArguments() {
    return getTypeArgumentList();
  }
  /**
   * 
     * Retrieves the TypeArgument list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the TypeArgument list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<Access> getTypeArgumentsNoTransform() {
    return getTypeArgumentListNoTransform();
  }
    /**
     * @attribute syn
     * @aspect LookupMethod
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupMethod.jrag:17
     */
  public Expr unqualifiedScope() {
    ASTNode$State state = state();
    try {  return getParent() instanceof Access ? ((Access)getParent()).unqualifiedScope() : super.unqualifiedScope();  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean type_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl type_value;
  /**
   * @attribute syn
   * @aspect GenericsTypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:273
   */

  public TypeDecl type() {
    

    
if(type_computed) {
  return type_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    type_value = type_compute();
      if(isFinal && num == state().boundariesCrossed){ type_computed = true; }
        return type_value;
  }
  /**
   * @apilevel internal
   */
  private TypeDecl type_compute() {
      TypeDecl typeDecl = genericDecl();
      if(typeDecl instanceof GenericTypeDecl) {
        // use signature in lookup for types that are used in extends and implements clauses
        if (unqualifiedScope().inExtendsOrImplements()) {
          return ((GenericTypeDecl)typeDecl).lookupParTypeDecl(this);
        }
        ArrayList args = new ArrayList();
        for(int i = 0; i < getNumTypeArgument(); i++)
          args.add(getTypeArgument(i).type());
        return ((GenericTypeDecl)typeDecl).lookupParTypeDecl(args);
      }
      return typeDecl;
    }
    /**
     * @attribute syn
     * @aspect GenericsTypeAnalysis
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:287
     */
  public TypeDecl genericDecl() {
    ASTNode$State state = state();
    try {  return getTypeAccess().type();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect AccessTypes
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ResolveAmbiguousNames.jrag:13
     */
  public boolean isTypeAccess() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
    /**
       * Builds a copy of this Access node where all occurrences
       * of type variables in the original type parameter list have been replaced
       * by the substitution type parameters.
       *
       * @return the substituted Access node
       
     * @attribute syn
     * @aspect Diamond
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/Diamond.jrag:406
     */
  public Access substituted(Collection<TypeVariable> original, List<TypeVariable> substitution) {
    ASTNode$State state = state();
    try {
        List<Access> substArgs = new List<Access>();
        for (Access arg : getTypeArgumentList())
          substArgs.add(arg.substituted(original, substitution));
        return new ParTypeAccess(
            getTypeAccess().substituted(original, substitution),
            substArgs);
      }
    finally {
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Generics.jrag:265
   * @apilevel internal
   */
  public SimpleSet Define_SimpleSet_lookupType(ASTNode caller, ASTNode child, String name) {
    if(caller == getTypeArgumentListNoTransform())  {
    int childIndex = caller.getIndexOfChild(child);
    return unqualifiedScope().lookupType(name);
  }
    else {      return getParent().Define_SimpleSet_lookupType(this, caller, name);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
