/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production RelationalExpr : {@link Binary};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:174
 */
public abstract class RelationalExpr extends Binary implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public RelationalExpr clone() throws CloneNotSupportedException {
    RelationalExpr node = (RelationalExpr) super.clone();
    return node;
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:204
   */

  public void typeCheck() {
    if(!getLeftOperand().type().isNumericType())
      error(getLeftOperand().type().typeName() + " is not numeric");
    if(!getRightOperand().type().isNumericType())
      error(getRightOperand().type().typeName() + " is not numeric");
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1049
   */

  public void createBCode(CodeGeneration gen) { emitBooleanCondition(gen); }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1145
   */

  public void emitEvalBranch(CodeGeneration gen) {
    if(isTrue())
      gen.emitGoto(true_label());
    else if(isFalse())
      gen.emitGoto(false_label());
    else {
      TypeDecl type = getLeftOperand().type();
      if(type.isNumericType()) {
        type = binaryNumericPromotedType();
        getLeftOperand().createBCode(gen);
        getLeftOperand().type().emitCastTo(gen, type); // Binary numeric promotion
        getRightOperand().createBCode(gen);
        getRightOperand().type().emitCastTo(gen, type); // Binary numeric promotion
      }
      else {
        getLeftOperand().createBCode(gen);
        getRightOperand().createBCode(gen);
      }
      compareBranch(gen, true_label(), type);
      gen.emitGoto(false_label());
      // compareNotBranch does not work for float comparison with NaN
      //compareNotBranch(gen, false_label(), type);
      //gen.emitGoto(true_label());
    }
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1171
   */

  public void compareBranch(CodeGeneration gen, int label, TypeDecl typeDecl) {
    throw new Error("compareBranch not supported for " + getClass().getName());
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1181
   */

  public void compareNotBranch(CodeGeneration gen, int label, TypeDecl typeDecl) {
    throw new Error("compareBranch not supported for " + getClass().getName());
  }
  /**
   * 
   * @ast method
   * 
   */

  public RelationalExpr() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public RelationalExpr(Expr p0, Expr p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        type_computed = false;
    type_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the LeftOperand child.
     * @param node The new node to replace the LeftOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setLeftOperand(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the LeftOperand child.
     * @return The current node used as the LeftOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getLeftOperand() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the LeftOperand child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the LeftOperand child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getLeftOperandNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the RightOperand child.
     * @param node The new node to replace the RightOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setRightOperand(Expr node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the RightOperand child.
     * @return The current node used as the RightOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getRightOperand() {
    return (Expr) getChild(1);
  }
  /**
   * 
     * Retrieves the RightOperand child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the RightOperand child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getRightOperandNoTransform() {
    return (Expr) getChildNoTransform(1);
  }
  /**
   * @apilevel internal
   */
  protected boolean type_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl type_value;
  /**
   * @attribute syn
   * @aspect TypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:344
   */

  public TypeDecl type() {
    

    
if(type_computed) {
  return type_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    type_value = type_compute();
      if(isFinal && num == state().boundariesCrossed){ type_computed = true; }
        return type_value;
  }
  /**
   * @apilevel internal
   */
  private TypeDecl type_compute() {  return typeBoolean();  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:968
     */
  public boolean definesLabel() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1016
   * @apilevel internal
   */
  public int Define_int_condition_false_label(ASTNode caller, ASTNode child) {
    if(caller == getRightOperandNoTransform()) {
      return false_label();
    }
    else if(caller == getLeftOperandNoTransform()) {
      return false_label();
    }
    else {      return getParent().Define_int_condition_false_label(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1017
   * @apilevel internal
   */
  public int Define_int_condition_true_label(ASTNode caller, ASTNode child) {
    if(caller == getRightOperandNoTransform()) {
      return true_label();
    }
    else if(caller == getLeftOperandNoTransform()) {
      return true_label();
    }
    else {      return getParent().Define_int_condition_true_label(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
