/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;

/**
 * @production Stmt : {@link ASTNode};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:193
 */
public abstract class Stmt extends ASTNode<ASTNode> implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public Stmt clone() throws CloneNotSupportedException {
    Stmt node = (Stmt) super.clone();
    return node;
  }
  /**
   * 
     * @return An Opt node containing the finally and monitor exit blocks
     * from the list of enclosing try-statements and synchronized blocks.
     
   * @ast method
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NTAFinally.jrag:80
   */

  public Opt<Block> branchFinallyOpt() {
    FinallyHost enclosing = enclosingFinally(this);
    if (enclosing != null) {
      return new Opt<Block>(ntaFinallyBlock(enclosing, this, enclosing.getFinallyBlock()));
    } else {
      return new Opt<Block>();
    }
  }
  /**
   * 
   * @ast method
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:14
   */

  void checkUnreachableStmt() {
    if(!reachable() && reportUnreachable())
      error("statement is unreachable");
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1196
   */

  public void createBCode(CodeGeneration gen) {
    gen.addLineNumberEntryAtCurrentPC(this);
  }
  /**
   * 
   * @ast method
   * 
   */

  public Stmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 0;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        finallyIterator_computed = false;
    finallyIterator_value = null;
    isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    canCompleteNormally_computed = false;
    enclosingFinally_Stmt_values = null;
    localNum_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * @attribute syn
   * @aspect PreciseRethrow
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
   */

@SuppressWarnings({"unchecked", "cast"})
  public abstract boolean modifiedInScope(Variable var);
  /**
   * @apilevel internal
   */
  protected boolean finallyIterator_computed = false;
  /**
   * @apilevel internal
   */
  protected Iterator<FinallyHost> finallyIterator_value;
  /**
     * Finds enclosing finally and monitor exit blocks.
     * @return an iterator for finally (and monitor exit) blocks that are
     * reached before the final target of this statement is reached
     
   * @attribute syn
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:59
   */

  public Iterator<FinallyHost> finallyIterator() {
    

    
if(finallyIterator_computed) {
  return finallyIterator_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    finallyIterator_value = finallyIterator_compute();
      if(isFinal && num == state().boundariesCrossed){ finallyIterator_computed = true; }
        return finallyIterator_value;
  }
  /**
   * @apilevel internal
   */
  private Iterator<FinallyHost> finallyIterator_compute() {
      return new LazyFinallyIterator(this);
    }
    /**
       * @return <code>true</code> if this statement can branch to
       * the target statement.
       
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:166
     */
  public boolean canBranchTo(BranchTargetStmt target) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:167
     */
  public boolean canBranchTo(LabeledStmt target) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:168
     */
  public boolean canBranchTo(SwitchStmt target) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:325
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {  return isDAbefore(v);  }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:777
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {
      throw new Error("isDUafter in " + getClass().getName());
    }
    /**
     * @attribute syn
     * @aspect VariableScope
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:129
     */
  public boolean declaresVariable(String name) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect NameCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:423
     */
  public boolean continueLabel() {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PrettyPrint
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:758
     */
  public boolean addsIndentationLevel() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:29
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return true;  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1446
     */
  public int break_label() {
    ASTNode$State state = state();
    try {
        throw new UnsupportedOperationException("Can not break at this statement of type " + getClass().getName());
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1470
     */
  public int continue_label() {
    ASTNode$State state = state();
    try {
        throw new UnsupportedOperationException("Can not continue at this statement");
      }
    finally {
    }
  }
  /**
     * @return the target statement for a break or continue
     
   * @attribute inh
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:206
   */

  public Stmt branchTarget(Stmt branch) {
    ASTNode$State state = state();
    Stmt branchTarget_Stmt_value = getParent().Define_Stmt_branchTarget(this, null, branch);
        return branchTarget_Stmt_value;
  }
  /**
     * Find finally block of enclosing try-statement, or monitor exit
     * block of enclosing synchronized block.
     * @param branch the source branch
     * @return a finally block, or <code>null</code> if there is no
     * enclosing try-statement
     
   * @attribute inh
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:242
   */

  public FinallyHost enclosingFinally(Stmt branch) {
    Object _parameters = branch;
    if(enclosingFinally_Stmt_values == null) enclosingFinally_Stmt_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(enclosingFinally_Stmt_values.containsKey(_parameters)) {
  return (FinallyHost)enclosingFinally_Stmt_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    FinallyHost enclosingFinally_Stmt_value = getParent().Define_FinallyHost_enclosingFinally(this, null, branch);
      if(isFinal && num == state().boundariesCrossed){ enclosingFinally_Stmt_values.put(_parameters, enclosingFinally_Stmt_value); }
        return enclosingFinally_Stmt_value;
  }
  protected java.util.Map enclosingFinally_Stmt_values;
  /**
   * @attribute inh
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:232
   */

  public boolean isDAbefore(Variable v) {
    ASTNode$State state = state();
    boolean isDAbefore_Variable_value = getParent().Define_boolean_isDAbefore(this, null, v);
        return isDAbefore_Variable_value;
  }
  /**
   * @attribute inh
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:691
   */

  public boolean isDUbefore(Variable v) {
    ASTNode$State state = state();
    boolean isDUbefore_Variable_value = getParent().Define_boolean_isDUbefore(this, null, v);
        return isDUbefore_Variable_value;
  }
  /**
   * @attribute inh
   * @aspect LookupMethod
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupMethod.jrag:24
   */

  public Collection lookupMethod(String name) {
    ASTNode$State state = state();
    Collection lookupMethod_String_value = getParent().Define_Collection_lookupMethod(this, null, name);
        return lookupMethod_String_value;
  }
  /**
   * @attribute inh
   * @aspect LookupFullyQualifiedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:96
   */

  public TypeDecl lookupType(String packageName, String typeName) {
    ASTNode$State state = state();
    TypeDecl lookupType_String_String_value = getParent().Define_TypeDecl_lookupType(this, null, packageName, typeName);
        return lookupType_String_String_value;
  }
  /**
   * @attribute inh
   * @aspect TypeScopePropagation
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:262
   */

  public SimpleSet lookupType(String name) {
    ASTNode$State state = state();
    SimpleSet lookupType_String_value = getParent().Define_SimpleSet_lookupType(this, null, name);
        return lookupType_String_value;
  }
  /**
   * @attribute inh
   * @aspect VariableScope
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupVariable.jrag:16
   */

  public SimpleSet lookupVariable(String name) {
    ASTNode$State state = state();
    SimpleSet lookupVariable_String_value = getParent().Define_SimpleSet_lookupVariable(this, null, name);
        return lookupVariable_String_value;
  }
  /**
   * @attribute inh
   * @aspect NestedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:511
   */

  public BodyDecl enclosingBodyDecl() {
    ASTNode$State state = state();
    BodyDecl enclosingBodyDecl_value = getParent().Define_BodyDecl_enclosingBodyDecl(this, null);
        return enclosingBodyDecl_value;
  }
  /**
   * @attribute inh
   * @aspect NestedTypes
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:587
   */

  public TypeDecl hostType() {
    ASTNode$State state = state();
    TypeDecl hostType_value = getParent().Define_TypeDecl_hostType(this, null);
        return hostType_value;
  }
  /**
   * @attribute inh
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:27
   */

  public boolean reachable() {
    ASTNode$State state = state();
    boolean reachable_value = getParent().Define_boolean_reachable(this, null);
        return reachable_value;
  }
  /**
   * @attribute inh
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:147
   */

  public boolean reportUnreachable() {
    ASTNode$State state = state();
    boolean reportUnreachable_value = getParent().Define_boolean_reportUnreachable(this, null);
        return reportUnreachable_value;
  }
  /**
     * Checks if the branch statement leaves the monitor.
     * @return <code>true</code> if the branch leaves the monitor
     
   * @attribute inh
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1662
   */

  public boolean leavesMonitor(Stmt branch, SynchronizedStmt monitor) {
    ASTNode$State state = state();
    boolean leavesMonitor_Stmt_SynchronizedStmt_value = getParent().Define_boolean_leavesMonitor(this, null, branch, monitor);
        return leavesMonitor_Stmt_SynchronizedStmt_value;
  }
  /**
     * @return The next available local variable index.
     
   * @attribute inh
   * @aspect LocalNum
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:17
   */

  public int localNum() {
    

    
if(localNum_computed) {
  return localNum_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    localNum_value = getParent().Define_int_localNum(this, null);
      if(isFinal && num == state().boundariesCrossed){ localNum_computed = true; }
        return localNum_value;
  }
  /**
   * @apilevel internal
   */
  protected boolean localNum_computed = false;
  /**
   * @apilevel internal
   */
  protected int localNum_value;
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:352
   * @apilevel internal
   */
  public String Define_String_typeDeclIndent(ASTNode caller, ASTNode child) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return indent();
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
