/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production SynchronizedStmt : {@link Stmt} ::= <span class="component">{@link Expr}</span> <span class="component">{@link Block}</span> <span class="component">{@link MonitorExit}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:215
 */
public class SynchronizedStmt extends Stmt implements Cloneable, FinallyHost {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public SynchronizedStmt clone() throws CloneNotSupportedException {
    SynchronizedStmt node = (SynchronizedStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public SynchronizedStmt copy() {
    try {
      SynchronizedStmt node = (SynchronizedStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public SynchronizedStmt fullCopy() {
    SynchronizedStmt tree = (SynchronizedStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        switch (i) {
        case 2:
          tree.children[i] = null;
          continue;
        }
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:919
   */

  public Block getFinallyBlock() {
    return getMonitorExit();
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:802
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	s.append(indent());
	s.append("synchronized(");
	getExpr().prettyPrint(s);
	s.append(") ");
	getBlock().prettyPrint(s);
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:699
   */

  public void toString(StringBuffer s) {
	s.append(indent());
	s.append("synchronized(");
	getExpr().toString(s);
	s.append(") ");
	getBlock().toString(s);
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:362
   */

  public void typeCheck() {
    TypeDecl type = getExpr().type();
    if(!type.isReferenceType() || type.isNull())
      error("*** The type of the expression must be a reference");
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1619
   */

  public void emitMonitorEnter(CodeGeneration gen) {
    gen.emitDup();
    int num = localNum();
    gen.emitStoreReference(num);
    gen.emit(Bytecode.MONITORENTER);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1635
   */

  

  protected int monitorId = -1;
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1637
   */

  public void createBCode(CodeGeneration gen) {
    int lbl_start = hostType().constantPool().newLabel();
    super.createBCode(gen);
    getExpr().createBCode(gen);

    monitorId = gen.monitorEnter(this);
    gen.addLabel(lbl_start);
    gen.monitorRangeStart(monitorId, lbl_start);

    getBlock().createBCode(gen);

    if (getBlock().canCompleteNormally()) {
      getMonitorExit().createBCode(gen);
      gen.emitGoto(label_end());
    }

    gen.monitorExit();

    gen.addLabel(label_end());
  }
  /**
   * 
   * @ast method
   * 
   */

  public SynchronizedStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[3];
  }
  /**
   * 
   * @ast method
   * 
   */

  public SynchronizedStmt(Expr p0, Block p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    getMonitorExit_computed = false;
    getMonitorExit_value = null;
    canCompleteNormally_computed = false;
    start_label_computed = false;
    label_end_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Expr child.
     * @param node The new node to replace the Expr child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setExpr(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Expr child.
     * @return The current node used as the Expr child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getExpr() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the Expr child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Expr child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getExprNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Block child.
     * @param node The new node to replace the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBlock(Block node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Block child.
     * @return The current node used as the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Block getBlock() {
    return (Block) getChild(1);
  }
  /**
   * 
     * Retrieves the Block child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Block getBlockNoTransform() {
    return (Block) getChildNoTransform(1);
  }
  /**
   * 
     * Replaces the MonitorExit child.
     * @param node The new node to replace the MonitorExit child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setMonitorExit(MonitorExit node) {
    setChild(node, 2);
  }
  /**
   * 
     * Retrieves the MonitorExit child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the MonitorExit child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public MonitorExit getMonitorExitNoTransform() {
    return (MonitorExit) getChildNoTransform(2);
  }
  /**
   * 
     * Retrieves the child position of the optional child MonitorExit.
     * @return The the child position of the optional child MonitorExit.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int getMonitorExitChildPosition() {
    return 2;
  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:655
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {  return getBlock().isDAafter(v);  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:924
     */
  public boolean isDUafterFinally(Variable v) {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:927
     */
  public boolean isDAafterFinally(Variable v) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1193
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {  return getBlock().isDUafter(v);  }
  /**
   * @apilevel internal
   */
  protected boolean getMonitorExit_computed = false;
  /**
   * @apilevel internal
   */
  protected MonitorExit getMonitorExit_value;
  /**
   * @attribute syn nta
   * @aspect MonitorExit
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/MonitorExit.jrag:11
   */

  public MonitorExit getMonitorExit() {
    

if(getMonitorExit_computed) {
  return (MonitorExit) getChild(getMonitorExitChildPosition());
}
    
if(getMonitorExit_computed) {
  return getMonitorExit_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    getMonitorExit_value = getMonitorExit_compute();
      setMonitorExit(getMonitorExit_value);
      if(isFinal && num == state().boundariesCrossed){ getMonitorExit_computed = true; }
    MonitorExit node = (MonitorExit) this.getChild(getMonitorExitChildPosition());
        return node;
  }
  /**
   * @apilevel internal
   */
  private MonitorExit getMonitorExit_compute() {  return new MonitorExit(this);  }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:110
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return getBlock().canCompleteNormally();  }
  /**
   * @apilevel internal
   */
  protected boolean start_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int start_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1455
   */

  public int start_label() {
    

    
if(start_label_computed) {
  return start_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    start_label_value = start_label_compute();
      if(isFinal && num == state().boundariesCrossed){ start_label_computed = true; }
        return start_label_value;
  }
  /**
   * @apilevel internal
   */
  private int start_label_compute() {  return hostType().constantPool().newLabel();  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return getBlock().modifiedInScope(var);  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean label_end_computed = false;
  /**
   * @apilevel internal
   */
  protected int label_end_value;
  /**
   * @attribute syn
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/NTAFinally.jrag:30
   */

  public int label_end() {
    

    
if(label_end_computed) {
  return label_end_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    label_end_value = label_end_compute();
      if(isFinal && num == state().boundariesCrossed){ label_end_computed = true; }
        return label_end_value;
  }
  /**
   * @apilevel internal
   */
  private int label_end_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:254
   * @apilevel internal
   */
  public FinallyHost Define_FinallyHost_enclosingFinally(ASTNode caller, ASTNode child, Stmt branch) {
    if(caller == getMonitorExitNoTransform()) {
      return enclosingFinally(branch);
    }
    else  {
      int childIndex = this.getIndexOfChild(caller);
      return this;
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:657
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getBlockNoTransform()) {
      return getExpr().isDAafter(v);
    }
    else if(caller == getExprNoTransform()) {
      return isDAbefore(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1195
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getBlockNoTransform()) {
      return getExpr().isDUafter(v);
    }
    else if(caller == getExprNoTransform()) {
      return isDUbefore(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:111
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:157
   * @apilevel internal
   */
  public boolean Define_boolean_reportUnreachable(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reportUnreachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1668
   * @apilevel internal
   */
  public boolean Define_boolean_leavesMonitor(ASTNode caller, ASTNode child, Stmt branch, SynchronizedStmt monitor) {
     {
      int childIndex = this.getIndexOfChild(caller);
{
    if (monitor == this)
      return true;
    else
      return leavesMonitor(branch, monitor);
  }
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/LocalNum.jrag:137
   * @apilevel internal
   */
  public int Define_int_localNum(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return localNum() + 3;
    }
    else {      return getParent().Define_int_localNum(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
