/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production WhileStmt : {@link BranchTargetStmt} ::= <span class="component">Condition:{@link Expr}</span> <span class="component">{@link Stmt}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:206
 */
public class WhileStmt extends BranchTargetStmt implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public WhileStmt clone() throws CloneNotSupportedException {
    WhileStmt node = (WhileStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public WhileStmt copy() {
    try {
      WhileStmt node = (WhileStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public WhileStmt fullCopy() {
    WhileStmt tree = (WhileStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:669
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	s.append(indent());
	s.append("while(");
	getCondition().prettyPrint(s);
	s.append(")");
	getStmt().prettyPrint(s);
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:587
   */

  public void toString(StringBuffer s) {
	s.append(indent());
	s.append("while(");
	getCondition().toString(s);
	s.append(")");
	getStmt().toString(s);
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:322
   */

  public void typeCheck() {
    TypeDecl cond = getCondition().type();
    if(!cond.isBoolean()) {
      error("the type of \"" + getCondition() + "\" is " + cond.name() + " which is not boolean");
    }
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1394
   */

  public void createBCode(CodeGeneration gen) {
    super.createBCode(gen);
    gen.addLabel(cond_label());
    getCondition().emitEvalBranch(gen);
    gen.addLabel(stmt_label());
    if(getCondition().canBeTrue()) {
      getStmt().createBCode(gen);
      if(getStmt().canCompleteNormally())
        gen.emitGoto(cond_label());
    }
    gen.addLabel(end_label());
  }
  /**
   * 
   * @ast method
   * 
   */

  public WhileStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public WhileStmt(Expr p0, Stmt p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    isDUbeforeCondition_Variable_values = null;
    canCompleteNormally_computed = false;
    cond_label_computed = false;
    end_label_computed = false;
    stmt_label_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Condition child.
     * @param node The new node to replace the Condition child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setCondition(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Condition child.
     * @return The current node used as the Condition child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getCondition() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the Condition child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Condition child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getConditionNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Stmt child.
     * @param node The new node to replace the Stmt child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setStmt(Stmt node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Stmt child.
     * @return The current node used as the Stmt child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Stmt getStmt() {
    return (Stmt) getChild(1);
  }
  /**
   * 
     * Retrieves the Stmt child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Stmt child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Stmt getStmtNoTransform() {
    return (Stmt) getChildNoTransform(1);
  }
    /**
       * @return <code>true</code> if this statement is a potential
       * branch target of the given branch statement.
       
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:196
     */
  public boolean potentialTargetOf(Stmt branch) {
    ASTNode$State state = state();
    try {  return branch.canBranchTo(this);  }
    finally {
    }
  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:576
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {
      if(!getCondition().isDAafterFalse(v))
        return false;
      for(Iterator iter = targetBreaks().iterator(); iter.hasNext(); ) {
        BreakStmt stmt = (BreakStmt)iter.next();
        if(!stmt.isDAafterReachedFinallyBlocks(v))
          return false;
      }
      return true;
    }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1047
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {
      if(!isDUbeforeCondition(v)) // start a circular evaluation here
        return false;
      if(!getCondition().isDUafterFalse(v))
        return false;
      for(Iterator iter = targetBreaks().iterator(); iter.hasNext(); ) {
        BreakStmt stmt = (BreakStmt)iter.next();
        if(!stmt.isDUafterReachedFinallyBlocks(v))
          return false;
      }
      return true;
    }
  protected java.util.Map isDUbeforeCondition_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1064
   */

  @SuppressWarnings({"unchecked", "cast"})
  public boolean isDUbeforeCondition(Variable v) {
    Object _parameters = v;
    if(isDUbeforeCondition_Variable_values == null) isDUbeforeCondition_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    ASTNode$State.CircularValue _value;
    

    
if(isDUbeforeCondition_Variable_values.containsKey(_parameters)) {
  Object _o = isDUbeforeCondition_Variable_values.get(_parameters);
  if(!(_o instanceof ASTNode$State.CircularValue)) {
    return ((Boolean)_o).booleanValue();
  } else { 
    _value = (ASTNode$State.CircularValue)_o;
  }
}
 else {
      _value = new ASTNode$State.CircularValue();
      isDUbeforeCondition_Variable_values.put(_parameters, _value);
      _value.value = Boolean.valueOf(true);
    }
    ASTNode$State state = state();
    if (!state.IN_CIRCLE) {
      state.IN_CIRCLE = true;
      int num = state.boundariesCrossed;
      boolean isFinal = this.is$Final();
      // TODO: fixme
      // state().CIRCLE_INDEX = 1;
      boolean new_isDUbeforeCondition_Variable_value;
      do {
        _value.visited = new Integer(state.CIRCLE_INDEX);
        state.CHANGE = false;
        new_isDUbeforeCondition_Variable_value = isDUbeforeCondition_compute(v);
        if (new_isDUbeforeCondition_Variable_value!=((Boolean)_value.value).booleanValue()) {
          state.CHANGE = true;
          _value.value = Boolean.valueOf(new_isDUbeforeCondition_Variable_value);
        }
        state.CIRCLE_INDEX++;
      } while (state.CHANGE);
        if(isFinal && num == state().boundariesCrossed) {
        isDUbeforeCondition_Variable_values.put(_parameters, new_isDUbeforeCondition_Variable_value);
      } else {
        isDUbeforeCondition_Variable_values.remove(_parameters);
        state.RESET_CYCLE = true;
isDUbeforeCondition_compute(v);
state.RESET_CYCLE = false;
      }
      state.IN_CIRCLE = false;
      return new_isDUbeforeCondition_Variable_value;
    }
    if (!new Integer(state.CIRCLE_INDEX).equals(_value.visited)) {
      _value.visited = new Integer(state.CIRCLE_INDEX);
      boolean new_isDUbeforeCondition_Variable_value = isDUbeforeCondition_compute(v);
      if (state.RESET_CYCLE) {
        isDUbeforeCondition_Variable_values.remove(_parameters);
      }
      else if (new_isDUbeforeCondition_Variable_value!=((Boolean)_value.value).booleanValue()) {
        state.CHANGE = true;
        _value.value = new_isDUbeforeCondition_Variable_value;
      }
      return new_isDUbeforeCondition_Variable_value;
    }
    return ((Boolean)_value.value).booleanValue();
  }
  /**
   * @apilevel internal
   */
  private boolean isDUbeforeCondition_compute(Variable v) {
      // 1st
      if(!isDUbefore(v))
        return false;
      else if(!getStmt().isDUafter(v))
        return false;
      else {
        for(Iterator iter = targetContinues().iterator(); iter.hasNext(); ) {
          ContinueStmt stmt = (ContinueStmt)iter.next();
          if(!stmt.isDUafterReachedFinallyBlocks(v))
            return false;
        }
      }
      return true;
    }
    /**
     * @attribute syn
     * @aspect NameCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:423
     */
  public boolean continueLabel() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:85
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return reachable() && (!getCondition().isConstant() || !getCondition().isTrue()) || reachableBreak();  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:968
     */
  public boolean definesLabel() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean cond_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int cond_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1390
   */

  public int cond_label() {
    

    
if(cond_label_computed) {
  return cond_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    cond_label_value = cond_label_compute();
      if(isFinal && num == state().boundariesCrossed){ cond_label_computed = true; }
        return cond_label_value;
  }
  /**
   * @apilevel internal
   */
  private int cond_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean end_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int end_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1391
   */

  public int end_label() {
    

    
if(end_label_computed) {
  return end_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    end_label_value = end_label_compute();
      if(isFinal && num == state().boundariesCrossed){ end_label_computed = true; }
        return end_label_value;
  }
  /**
   * @apilevel internal
   */
  private int end_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean stmt_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int stmt_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1392
   */

  public int stmt_label() {
    

    
if(stmt_label_computed) {
  return stmt_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    stmt_label_value = stmt_label_compute();
      if(isFinal && num == state().boundariesCrossed){ stmt_label_computed = true; }
        return stmt_label_value;
  }
  /**
   * @apilevel internal
   */
  private int stmt_label_compute() {  return hostType().constantPool().newLabel();  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1446
     */
  public int break_label() {
    ASTNode$State state = state();
    try {  return end_label();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1470
     */
  public int continue_label() {
    ASTNode$State state = state();
    try {  return cond_label();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return getStmt().modifiedInScope(var);  }
    finally {
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:216
   * @apilevel internal
   */
  public Stmt Define_Stmt_branchTarget(ASTNode caller, ASTNode child, Stmt branch) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return branch.canBranchTo(this) ? this : branchTarget(branch);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:587
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getStmtNoTransform()) {
      return getCondition().isDAafterTrue(v);
    }
    else if(caller == getConditionNoTransform()) {
      return isDAbefore(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1081
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getStmtNoTransform()) {
      return getCondition().isDUafterTrue(v);
    }
    else if(caller == getConditionNoTransform()) {
      return isDUbeforeCondition(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:393
   * @apilevel internal
   */
  public boolean Define_boolean_insideLoop(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_insideLoop(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:86
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return reachable() && !getCondition().isFalse();
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:153
   * @apilevel internal
   */
  public boolean Define_boolean_reportUnreachable(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reportUnreachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:987
   * @apilevel internal
   */
  public int Define_int_condition_false_label(ASTNode caller, ASTNode child) {
    if(caller == getConditionNoTransform()) {
      return end_label();
    }
    else {      return getParent().Define_int_condition_false_label(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:988
   * @apilevel internal
   */
  public int Define_int_condition_true_label(ASTNode caller, ASTNode child) {
    if(caller == getConditionNoTransform()) {
      return stmt_label();
    }
    else {      return getParent().Define_int_condition_true_label(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
